SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-UI-Models'!
SystemOrganization addCategory: #'SqueakSVN-UI-SystemBrowserExtension'!
SystemOrganization addCategory: #'SqueakSVN-UI-Tests'!
SystemOrganization addCategory: #'SqueakSVN-UI-Tools'!
SystemOrganization addCategory: #'SqueakSVN-TestBase'!
SystemOrganization addCategory: #'SqueakSVN-TestBase-Test'!

OBCmdMultiView subclass: #OBSVNCmdMultiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNCmdMultiView methodsFor: 'execution' stamp: 'cop 3/4/2008 14:51'!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint Blame).
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 3/6/2008 12:49'!
setTextInDefinitionPanelFor: aTextOrString

	(requestor announce: OBAboutToChange) isVetoed
		ifFalse: [requestor
				announce: (OBDefinitionChanged definition: (OBSVNBlameDefinition new setText: aTextOrString;
							 yourself))]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 3/6/2008 12:46'!
setTextInDefinitionPanelForBlame: aTextOrString

	(requestor announce: OBAboutToChange) isVetoed
		ifFalse: [requestor
				announce: (OBDefinitionChanged definition: (OBSVNBlameDefinition new setTextWithBlame: aTextOrString;
							 yourself))]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 3/4/2008 15:18'!
toggleBlame
	self setTextInDefinitionPanelForBlame: 'Here is the blame text.'! !

OBReadOnlyDefinition subclass: #OBSVNBlameDefinition
	instanceVariableNames: 'blame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 3/6/2008 13:28'!
blame
	^blame! !

!OBSVNBlameDefinition methodsFor: 'initialize-release' stamp: 'cop 3/6/2008 12:58'!
initialize
	super initialize.
	blame := false.! !

!OBSVNBlameDefinition methodsFor: 'callbacks' stamp: 'cop 3/4/2008 15:22'!
setTextWithBlame: aText
	text := aText.
	blame := true.! !

OBDefinitionPanel subclass: #OBSVNDefinitionPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 3/6/2008 13:18'!
definition
	^definition! !

OBMetagraphBuilder subclass: #OBSVNMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:21'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBSVNStatusIconClassFilter new! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:19'!
populateMethodNode

	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:; "What's that? 'Needed??"
		addFilter: OBSVNStatusIconMethodFilter new! !

OBMorphBuilder subclass: #OBSVNMorphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNMorphBuilder methodsFor: 'building' stamp: 'cop 3/6/2008 13:01'!
textarea: aDefinitionPanel with: aBlock 
	"see CodeHolder>>buildMorphicCodePaneWith:"

	| morph shoutInstalled morphClass |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	morphClass := shoutInstalled 
				ifTrue: [OBSVNPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].
	morph := morphClass 
				on: aDefinitionPanel
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:.
	morph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	current ifNotNil: [current addMorphBack: morph].
	^self current: morph do: aBlock! !

OBPlatform subclass: #OBSVNMorphicPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNMorphicPlatform methodsFor: 'as yet unclassified' stamp: 'cop 3/6/2008 13:14'!
handleBrowseRequest: request
	^ OBSVNMorphBuilder open: request browser! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: 'sut hasTouchedFileSystem hasModifiedSVNDummy directoryManager slash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClassTest subclass: #PoolDictionariesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
nameOfPoolDictionary
	^ 'TestStoringAndRestoringOfPoolDictionariesClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:17'!
nameOfTestClass
	^ 'PoolDictionariesTestClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
setUp
	
	super setUp.
	
	self willTouchFileSystem.
	self willNeedRepositoryAndWorkingCopy.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	Smalltalk at: (self nameOfPoolDictionary asSymbol) put: (Dictionary new).
	
	Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: self nameOfPoolDictionary
		category: self class category asString.! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:38'!
tearDown

	super tearDown.

	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:43'!
testStoringAndRestoringOfPoolDictionaries

	| svnProject |
	svnProject := SVNProject checkoutProject: 'TestPro' fromURL: self repositoryURLPath inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	
	svnProject addClass: (Smalltalk classNamed: self nameOfTestClass).
	svnProject commit.

	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	self deny: (Smalltalk classNamed: self nameOfTestClass) notNil.
	
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	
	"restore"
	svnProject load.
	
	"check"
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) notNil.
	self assert: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	self assert: (Smalltalk at: self nameOfTestClass asSymbol) poolDictionaryNames =( OrderedCollection with: self nameOfPoolDictionary asSymbol).! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rt 3/10/2008 13:18'!
assertSVNClass: aSVNClass hasStateFromSystemClass: aClass 
	| instanceMethodSelectors expectedMethodSelectors classMethodSelectors expectedclassMethodSelectors |
	self assert: aSVNClass theName = aClass name.
	self assert: aSVNClass superclassName = aClass superclass name.
	self assert: aSVNClass instanceVariables = aClass instVarNames.
	self assert: aSVNClass classVariables = aClass classVarNames.
	self assert: aSVNClass classInstanceVariables = aClass class instVarNames.
	self assert: aSVNClass comment = aClass comment.
	self assert: aSVNClass category = aClass category.
	self flag: #TODO.
	"Implementation details about the file mapping
	are spread here"
	instanceMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass not])
				collect: [:each | each theName].
	expectedMethodSelectors := aClass methodDict
				collect: [:each | each selector asString].
	self assert: instanceMethodSelectors asSet = expectedMethodSelectors asSet.
	classMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass])
				collect: [:each | each theName].
	expectedclassMethodSelectors := aClass class methodDict
				collect: [:each | each selector asString].
	self assert: classMethodSelectors asSet = expectedclassMethodSelectors asSet! !

!SVNClassTest methodsFor: 'helper' stamp: 'rt 3/9/2008 20:01'!
configureSVNClass: svnClass forLoadingClassNamed: aString 
	
	svnClass
		theName: aString;
		superclassName: 'Object';
		instanceVariables: 'a';
		classVariables: 'A';
		classInstanceVariables: 'b';
		poolDictionaries: '';
		comment: '';
		category: self class category.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'test 3/15/2008 05:37'!
testAllClassMethodsExists

	| expectedFileNames class svnDirectory classDirectory directoryOfMethods actualFileNames |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	sut storeIn: svnDirectory.
	classDirectory := svnDirectory getSubDirectoryNamed: class name asString.
	self flag: #TODO. "Mapping implementation is spread here..."
	directoryOfMethods := (classDirectory getSubDirectoryNamed: 'class').
	expectedFileNames := (class class methodDict collect: [:each | each selector asString]) asSet.
	actualFileNames := directoryOfMethods files collect: [:each | each theName].
	self assert: expectedFileNames = actualFileNames.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 3/5/2008 20:25'!
testAllInstanceMethodsExists
	| expectedFileNames class svnDirectory classDirectory directoryOfMethods actualFileNames |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	sut storeIn: svnDirectory.
	classDirectory := svnDirectory getSubDirectoryNamed: class name asString.
	self flag: #TODO.
	"Mapping implementation is spread here..."
	directoryOfMethods := classDirectory getSubDirectoryNamed: 'instance'.
	self assert: directoryOfMethods notNil.
	expectedFileNames := (class methodDict
				collect: [:each | each selector asString]) asSet.
	actualFileNames := directoryOfMethods files
				collect: [:each | each theName].
	self assert: expectedFileNames = actualFileNames! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:07'!
testCreatingForExistingClassInitializesSVNClassCorrectly

	| class |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 3/4/2008 03:08'!
testCreatingForSerializedClassInitializesSVNClassCorrectly

	| class classFilesCreator svnDirectory classDirectory |
	class := self svnDummy.
	classFilesCreator := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	classFilesCreator storeIn: svnDirectory.
	classDirectory := (svnDirectory getSubDirectoryNamed: class name asString).
	sut := SVNClass forSerializedClassIn: classDirectory.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 3/14/2008 16:22'!
testDeleteClass

	| svnClass class |
	class := Object
				subclass: #OnlyForThisTest
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
				
	svnClass := SVNClass forExistingClass: class.
	class removeFromSystem.
	
	self assert: (svnClass theClass isNil).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:08'!
testEqual

	| class sut1 sut2 |
	class := self svnDummy.
	sut1 := SVNClass forExistingClass: class.
	sut2 := SVNClass forExistingClass: class.
	self assert: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 3/8/2008 22:45'!
testGetSVNMethodsFromClass

	| class expectedInstanceMethods expectedClassMethods |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	expectedInstanceMethods := class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	expectedClassMethods := class class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	self assert: sut versionedMethods = (expectedInstanceMethods union: expectedClassMethods) asSet.
	"self assert: sut methods = expectedInstanceMethods asSet.
	self assert: sut classMethods = expectedClassMethods asSet."! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 3/4/2008 06:43'!
testLoadClass
	
	| className |
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	[sut load.
	self assert: (Smalltalk hasClassNamed: className).
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [ Smalltalk
				at: className
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 3/4/2008 06:52'!
testLoadExistingClassAndRestoreDeletedMethod
	
	| class methodSelector |
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNClass forExistingClass: class.
	sut notifyAboutSystemModifications: false.
	class removeSelector: methodSelector.
	sut load.
	self assert: (self svnDummy selectors includes: methodSelector).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 06:50'!
testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod

	| class methodSelector |
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNClass forExistingClass: class.
	self assert: (class selectors includes: methodSelector).
	sut removeSVNMethod: (SVNMethod forExistingMethod: class >> methodSelector).
	sut load.
	self deny: (class selectors includes: methodSelector).
	self restoreSVNDummy.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:08'!
testNotEqual

	| sut1 sut2 |
	sut1 := SVNClass forExistingClass: self svnDummy.
	sut2 := SVNClass forExistingClass: self class.
	self deny: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'test 3/15/2008 02:34'!
testRemoveClassFromVersioningControl

	| svnProject svnClass |
	self flag: #TODO.
	self willTouchFileSystem.
	svnProject := SVNProject named: 'TestPro'.
	svnProject workingCopyDirectory: self defaultSVNDirectory.
	svnClass := SVNClass forExistingClass: self svnDummy.
	svnProject addSVNClass: svnClass.
	
	svnProject removeClass: self svnDummy.
	
	self deny: (svnProject versionedClasses includes: svnClass).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 3/9/2008 01:13'!
testRemoveMethod

	| svnMethod class |
	class := self svnDummy.
	sut := SVNClass forExistingClass: class.
	svnMethod := sut versionedMethods
		detect: [:ea | ea theName = 'm2']
		ifNone: [self assert: false].
	sut removeSVNMethod: svnMethod.
	self deny: (sut versionedMethods includes: svnMethod).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rt 3/9/2008 01:59'!
testRetrievesSystemNotification

	| class methodSelector |
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNClass forExistingClass: class.
	sut notifyAboutSystemModifications: true.
	self assert: (sut versionedMethods anySatisfy: [:ea | (ea theName asSymbol = methodSelector asSymbol) and: [ea nameOfClass = sut theName]]).
	class removeSelector: methodSelector.
	self assert: (sut versionedMethods noneSatisfy: [:ea | (ea theName asSymbol = methodSelector asSymbol) and: [ea nameOfClass = sut theName]]).! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rt 2/29/2008 02:58'!
testWriteClassDetailsFile

	"| sut svnDirectory expectedFileName createdFile |
	sut := SVNClass forExistingClass: SVNDummy.
	svnDirectory := self defaultSVNDirectory.
	sut storeClassDetailsIn: svnDirectory.
	expectedFileName := 'properties'.
	self assert: (svnDirectory fileExists: expectedFileName).
	createdFile := svnDirectory getFileNamed: expectedFileName.
	self assert: self classPropertiesForTests = createdFile content."! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'rkrk 3/4/2008 05:45'!
testWriteCommentFile

	| svnDirectory expectedFileName createdFile |
	sut := SVNClass forExistingClass: self svnDummy.
	svnDirectory := self defaultSVNDirectory.
	sut storeCommentIn: svnDirectory.
	expectedFileName := sut nameForCommentFile.
	self assert: (svnDirectory fileExists: expectedFileName).
	createdFile := svnDirectory getFileNamed: expectedFileName.
	self assert: self svnDummy comment = createdFile content.! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: 'fileToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/13/2008 22:07'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:01'!
tearDown
	super tearDown.
	"self halt."! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: self workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:18'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 02:08'!
testSvnAddPropertyWithValueTo

	| path fstream propertyPath propertiesContents |
	path := self workingCopyPath , self slash , fileToAdd.
	propertyPath := FileDirectory on: self workingCopyPath , self slash ,'.svn', self slash, 'props'.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	
	fstream := propertyPath readOnlyFileNamed: 'testFile.svn-work'.
	propertiesContents := fstream contents.
	fstream close.
	
	self assert: (propertiesContents includesSubString: 'propertyName').
	self assert: (propertiesContents includesSubString: 'value').
	! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:41'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: {workingCopyPath , self slash , fileToAdd}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnCheckoutRevisionByNumber

	"create new revisions"
	| firstFileName pathToFirstFile secondFileName pathToSecondFile workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	firstFileName := 'fileForFirstRevision'.
	pathToFirstFile := workingCopyPath , self slash , firstFileName.
	self createFile: pathToFirstFile.
	self assertThatFiles: {firstFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToFirstFile.
	sut svnCommit: {pathToFirstFile}.
	
	secondFileName := 'fileForSecondRevision'.
	pathToSecondFile := workingCopyPath , self slash , secondFileName.
	self createFile: pathToSecondFile.
	self assertThatFiles: {secondFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.
	
	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	self assert: (workingcopyDirectory fileExists: firstFileName).
	self deny: (workingcopyDirectory fileExists: secondFileName).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testSvnCommit

	| path startRevision endRevision |
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: {path , self slash , fileToAdd}.

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:30'!
testSvnCommitWithMessage
	| path message message1 revisionNumber|
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	message := 'this is a log message'.
	revisionNumber := sut svnGetHeadRevision:path.
	
	sut 
		svnCommit: {  (path , self slash , fileToAdd)  }
		withMessage: message.
	message1 := sut 
		svnGetCommitLogFrom: path , self slash , fileToAdd with: revisionNumber.
	self assert: message1 = message! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:34'!
testSvnCommitWithMessageAndRevsionNumber
	| path message message1 message2 revisionNumber stream|
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	message := 'this is a log message'.
	message1 := 'this is another logMessage'.
	"revisionNumber := sut svnGetHeadRevision:path."
	
	sut svnCommit: {  (path , self slash , fileToAdd)  }withMessage: message.
	revisionNumber := sut svnGetHeadRevision:path.
	message2 := sut svnGetCommitLogFrom: path , self slash , fileToAdd with: revisionNumber.
	self assert: message2 = message.	
	
	
	stream := FileStream fileNamed: (path , self slash , fileToAdd).
	stream nextPutAll:'123';
		close.
	sut svnCommit: {path , self slash , fileToAdd} withMessage: message1.
	revisionNumber := sut svnGetHeadRevision:path.
	message2 := sut
		svnGetCommitLogFrom: path , self slash , fileToAdd
		with: revisionNumber - 1.
	self assert: message2 = message.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:34'!
testSvnDeleteFromWorkingCopyWithCommittedItems

	| file dir |
	file := self workingCopyPath , self slash , 'file'.
	dir := self workingCopyPath , self slash , 'dir'.
	
	self createFile: file.
	(FileDirectory on: dir) assureExistence.
	
	sut svnAdd: file.
	sut svnAdd: dir.
	sut svnCommit: {file. dir}.
	
	sut svnDeleteTargetsFromWorkingCopy: {file. dir}.
	
	self assert: (FileDirectory new directoryExists: dir).
	self deny: (FileDirectory new fileExists: file).
	
	sut svnCommit: {dir. file}.
	
	self deny:
			((FileDirectory new fileExists: file) or:
			[(FileDirectory new directoryExists: dir)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnDeleteFromWorkingCopyWithUncommittedItems

	| file1 file2 dir1 dir2 workingCopyPathTemplate |
	workingCopyPathTemplate := self workingCopyPath , self slash.
	file1 := workingCopyPathTemplate , 'file1'.
	file2 := workingCopyPathTemplate , 'file2'.
	dir1 := workingCopyPathTemplate , 'dir1'.
	dir2 := workingCopyPathTemplate , 'dir2'.
	
	self createFile: file1.
	self createFile: file2.
	(FileDirectory on: dir1) assureExistence.
	(FileDirectory on: dir2) assureExistence.
	
	sut svnAdd: file2.
	sut svnAdd: dir2.
	
	sut svnDeleteTargetsFromWorkingCopy: {file1. file2. dir1. dir2}.
	
	self deny:
			((FileDirectory new fileExists: file1) or:
			[(FileDirectory new fileExists: file2)] or:
			[(FileDirectory new directoryExists: dir1)] or:
			[(FileDirectory new directoryExists: dir2)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:33'!
testSvnGetPropertyFrom

	| path property properties |
	
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	properties := sut svnGetPropertiesFrom: path.
	property := properties
		at: 'propertyName'
		ifAbsent: [self assert: false].
	
	self assert: (property = 'value').! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:38'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory pathToFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: {workingCopyPath}.
	
	"check if succeeded"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:38'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile pathToFile pathToSecondFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create new revisions"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.
	
	secondFile := 'fileForSecondRevision'.
	pathToSecondFile := self pathTo: secondFile inDir: workingCopyPath.
	self createFile: pathToSecondFile.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.

	"recover the first revision"
	sut 
		svnUpdateTargets: {workingCopyPath}
		toRevisionByNumber: 1.

	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile)! !

SVNCApiClientTest subclass: #SVNMyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMyTest methodsFor: 'tests' stamp: 'cop 3/11/2008 10:30'!
testSvnGetBlameLinesFor
	
	| pathToFile firstLine secondLine blameLines |	
	"Prepare the lines"
	firstLine := 'A line'.
	secondLine := 'Another line'.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	
	"Write something into the testFile"
	self inFile: pathToFile write: firstLine, String cr, secondLine.
	
	"Add it and commit it"
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.
	
	"Get blame lines"
	blameLines := sut svnGetBlameLinesFrom: pathToFile.

	"check if succeeded"
	self assert: (blameLines isEmpty not ).
	self assert: (blameLines at: 1 = '1' ).
	self assert: (blameLines at: 2 = '1' ).
	self assert: (blameLines at: 5 = firstLine ).
	self assert: (blameLines at: 6 = '2' ).
	self assert: (blameLines at: 7 = '1' ).
	self assert: (blameLines at: 10 = secondLine ).! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:06'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopy.
	
	fileToAdd := 'testFile'.
	self createFile: self workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 13:25'!
testCommandForAddProperty


	| key value path result expected |
	sut := SVNCommandLineClient new.
	key := 'irgendEinKey'.
	value := 'irgendEinValue'.
	path := SmalltalkImage current imagePath.
	result := sut buildCmdPropset: key value: value for: path.
	expected := 'svn propset ' , key , ' ' , value , ' ' , path.
	self assert: result = expected.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:19'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:49'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:48'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnCommit

	| path startRevision endRevision |
	path := self workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: self workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: self workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 23:55'!
setUp

	super setUp.
	sut := SVNClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:54'!
testBackslashToSlash

	| validPath |
	validPath := sut normalizePath: 'C:\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 11:17'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := sut normalizePath: 'C:\\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:59'!
testRemoveLastSlash

	| path |
	path := sut normalizePath: 'C:\test\test\'.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:08'!
createClassNamed: nameOfClass

	^ Object
		subclass: nameOfClass asSymbol
		instanceVariableNames: 'i1'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM1For: class

	class compile: 'm1' , String cr , '^ ''Heeeee Yaaaahhhhhhh'''.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM2For: class

	class compile: 'm2: argument' , String cr , '^ argument asString'.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/4/2008 02:18'!
nameOfAClass
	^ 'ClassCreatedInSVNAccepatanceTests'! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'running' stamp: 'rkrk 3/4/2008 05:40'!
tearDown

	super tearDown.
	Smalltalk
		at: self nameOfAClass asSymbol
		ifPresent: [:class | class removeFromSystemUnlogged].
	self flag: #TODO.
	self restoreSVNDummy.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'rt 3/14/2008 13:49'!
test01

	| svnProject class workingCopyDir readSVNProject projectName readDirectory |
	self flag: #TODO. "Merge with test02"
	self willNeedRepositoryAndWorkingCopy.
	"Create new project. Create new class. Add it to the project and commit."
	projectName := 'NewProject'.
	svnProject := SVNProject named: projectName.
	class := self createClassNamed: self nameOfAClass.
	self createMethodM1For: class.
	self createMethodM2For: class.
	"self halt."
	workingCopyDir := SVNDirectory on: self workingCopyPath.
	svnProject
		workingCopyDirectory: workingCopyDir;
		addClass: class;
		commit.
	"Read the project"
	readDirectory := SVNDirectory named: projectName basePath: self workingCopyPath.
	readDirectory read.
	readSVNProject := SVNProject restoreFrom: readDirectory.
	self assert: readSVNProject = svnProject.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'rt 3/14/2008 13:54'!
test02

	| svnProject workingCopyDirectory newSVNProject svnClass newWorkingCopyDirectory newWorkingCopyPath |
	self willNeedRepositoryAndWorkingCopy.
	"create and modify a SVNProject"
	svnClass := SVNClass
		name: self nameOfAClass
		superclassName: 'Object'
		instanceVariables: {}
		classVariables: Set new
		classInstanceVariables: {}
		poolDictionaries: OrderedCollection new
		comment: ''
		category: 'neu'.
	svnProject := SVNProject named: 'TestProject'.
	"define a working copy directory"
	workingCopyDirectory := SVNDirectory on: self workingCopyPath.
	svnProject workingCopyDirectory: workingCopyDirectory.
	svnProject addSVNClass: svnClass.
	"commit the changes"
	svnProject repositoryURL: self repositoryURLPath. "Not needed!!"
	svnProject commit.
	"self halt."
	"delete project and working copy"
	svnProject unload.
	self deny: (Smalltalk hasClassNamed: self nameOfAClass).
	"checkout the project in a new working copy"
	newWorkingCopyPath := self pathForTests , self slash , 'newWorkingCopy'.
	newWorkingCopyDirectory := SVNDirectory on: newWorkingCopyPath.
	newSVNProject := SVNProject
		checkoutProject: 'TestProject' 
		fromURL: self repositoryURLPath
		inWorkingCopy: newWorkingCopyDirectory.
	"load it into the system"
	newSVNProject load.
	"check if the old state is restored"
	self assert: (Smalltalk hasClassNamed: self nameOfAClass).
	self flag: #TODO. "Check if methods are there"! !

SVNTestCase subclass: #SVNCreateProjectDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 3/4/2008 02:10'!
fullPath

	^ FileDirectory fullPathForURI: ''! !

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 3/4/2008 02:07'!
setUp

	super setUp.
	sut := SVNCreateProjectDialog new.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 3/4/2008 02:10'!
testWorkingCopyPath

	| path |
	path := self fullPath , 'workingCopy'.
	self assert: (sut setWorkingCopyPath: path).
	self assert: (path = sut workingCopyPath).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 3/4/2008 02:11'!
testWorkingCopyPathRelative

	| path |
	path := 'workingCopy'.
	self assert: (sut setWorkingCopyPath: path).
	self assert: (sut workingCopyPath = (self fullPath , path)).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 3/4/2008 02:11'!
testWorkingCopyPathWithBackSlash

	| path fullpath |
	path := '.\workingCopy\subdir'.
	
	self assert: (sut setWorkingCopyPath: path).
	fullpath := self fullPath , path.
	
	self assert: fullpath = sut workingCopyPath.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 3/4/2008 02:11'!
testWorkingCopyPathWithSlash

	| path fullpath |
	path := './workingCopy/subdir'.
	
	self assert: (sut setWorkingCopyPath: path).
	fullpath := self fullPath , 'workingCopy' , self slash , 'subdir'.
	
	self assert: fullpath = sut workingCopyPath.! !

SVNTestCase subclass: #SVNDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNDirectoryTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNDirectory
		named: 'svnDirectoryWhichIsTested'
		basePath: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 3/13/2008 14:31'!
testAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 3/13/2008 15:13'!
testAddDirectoryWithSubdirectoriesAndFiles

	| directoryName subDirectoryName fileName subDir |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	subDirectoryName := 'SubDirectory'.
	fileName := 'file'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	subDir := sut createSubDirectoryNamed: subDirectoryName.
	subDir createFileNamed: fileName.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.
	self
		assertFile: subDirectoryName
		wasSVNAddedIn: sut path.
	self
		assertFile: fileName
		wasSVNAddedIn: sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/5/2008 01:33'!
testAddFilesWithPropertiesWhichAreInTheEndEqual

	| filename assoc |
	sut := SVNDirectory
		named: 'svnDir'
		basePath: self pathForTests.
	filename := 'fileName'.
	assoc := 'key' -> 'value'.
	(sut createFileNamed: filename) properties add: assoc.
	(sut createFileNamed: filename) properties add: assoc.

	self assert: sut files size = 1.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:07'!
testAddTwoTimesTheSameFile

	| file |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	file := SVNFile named: 'test' basePath: sut path.
	sut files
		add: file;
		add: file.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rt 3/14/2008 15:49'!
testCommitARemovedDirectory

	| fileName |
	"create"

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
				named: 'TestDir'
				basePath: self workingCopyPath.
	fileName := 'iAmAFile'.
	sut
		createFileNamed: fileName;
		store;
		commit.
	
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self
		assertThatFiles: {fileName}
		existsIn: (self workingCopyPath , '2', self slash, sut theName).
	
	"remove"
	sut
		remove;
		commit.
	
	"check"
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self deny: (FileDirectory on: self workingCopyPath , '2', self slash, sut theName) exists.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/22/2008 13:47'!
testCreateFile

	| sut fileName expectedFile resultFile |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'aNewFile'.
	sut createFileNamed: fileName.
	expectedFile := SVNFile  
		named: fileName
		basePath: sut path.
	self assert: sut files size = 1.
	resultFile := sut files someElement.
	self assert: expectedFile = resultFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:48'!
testCreateSubDirectory

	| subDirectoryName expectedDirectory resultDirectory |
	subDirectoryName := 'subDirectory'.
	sut createSubDirectoryNamed: subDirectoryName.
	expectedDirectory := SVNDirectory 
		named: subDirectoryName
		basePath: sut path.
	self assert: sut subdirectories size = 1.
	resultDirectory := sut subdirectories someElement.
	self assert: expectedDirectory = resultDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:13'!
testCreateTwoTimesTheSameFile

	| fileName |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	sut
		createFileNamed: fileName;
		createFileNamed: fileName.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:10'!
testCreateTwoTimesTheSameFileWithContent

	| fileName content |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	content := 'abc'.
	sut
		createFileNamed: fileName
		withContent: content.
	sut
		createFileNamed: fileName
		withContent: content.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 00:19'!
testCreateWithOn

	sut := SVNDirectory on: self pathForTests.
	FileDirectory
		splitName: self pathForTests
		to: [:dirPath :localName |
			self assert: sut basePath = dirPath.
			self assert: sut theName = localName].
	! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 05:30'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	sut recursivelyDo: [:svnDirectoryEntry |
		svnDirectoryEntry delete].
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:50'!
testDirectoryExists

	| directoryName |
	directoryName := 'iAmADirectory'.
	sut createSubDirectoryNamed: directoryName.
	self assert: (sut directoryExists: directoryName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:53'!
testDontStoreSubdirectoriesMultipleSubdirectoriesWithTheSameName

	| newSubdir1 newSubdir2 subdirFromSut key value |
	newSubdir1 := SVNDirectory named: 'subdir' basePath: sut path.
	sut addSubdirectory: newSubdir1.
	newSubdir2 := SVNDirectory named: 'subdir' basePath: sut path.
	key := 'key'.
	value := 'value'.
	newSubdir2 properties at: key put: value.
	sut addSubdirectory: newSubdir2.
	self assert: sut subdirectories size = 1.
	subdirFromSut := sut subdirectories someElement.
	self assert: (subdirFromSut properties at: key) = value.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:32'!
testFileExists

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	self assert: (sut fileExists: fileName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:58'!
testFilesMustHaveTheCorrectBasePath01

	| newFile |
	newFile := SVNFile
		named: 'new'
		basePath: 'Not/existing'.
	sut addFile: newFile.
	self assert: newFile basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:01'!
testGatherPathsOfAllElements

	| dirName fileName expected1 expected2 result |
	dirName := 'dir1'.
	fileName := 'file1'.
	sut
		createSubDirectoryNamed: dirName;
		createFileNamed: fileName.
	expected1 := sut path , self slash , dirName.
	expected2 := sut path , self slash , fileName.
	result := sut recursivelyGatherPathsOfAllElements.
	self assert: result size = 2.
	self assert: (result includes: expected1).
	self assert: (result includes: expected2).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:36'!
testGetFileNamed

	| fileName svnFile |
	fileName := 'iAmAFile'.
	svnFile := sut createFileNamed: fileName.
	self assert: (sut getFileNamed: fileName) = svnFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:53'!
testGetSubDirectoryNamed

	| directoryName svnDirectory |
	directoryName := 'iAmADirectory'.
	svnDirectory := sut createSubDirectoryNamed: directoryName.
	self assert: (sut getSubDirectoryNamed: directoryName) = svnDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:49'!
testReadExistingDirectory

	self
		createDirNamed: sut theName
		in: sut basePath.
	self shouldnt: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 00:54'!
testReadNonExistingDirectory

	sut := SVNDirectory
		named: 'blablabla'
		basePath: 'auf/dem/Mond'.
	self should: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 00:54'!
testRecursiveReadOnlyWithDirectories

	| subDirPath subDirName subSubDirPath subSubDirName expectedSVNSubDirectory |
	self willTouchFileSystem.
	"1st level. Create real directory for the topmost SVNDirectory."
	subDirPath := self createDirNamed: sut theName in: sut basePath.
	"2nd level. Create a directory in the topmost SVNDirectory"
	subDirName := 'subdir'.
	subSubDirPath := self createDirNamed: subDirName in: subDirPath.
	"3rd level. Create a subdirectoy to the directory created just now. "
	subSubDirName := 'subsubdir'.
	self createDirNamed: subSubDirName in: subSubDirPath.
	
	"Now create the equivalent SVNDirectories"
	expectedSVNSubDirectory := SVNDirectory
		named: subDirName
		basePath: subDirPath.
	expectedSVNSubDirectory createSubDirectoryNamed: subSubDirName.
	
	sut read.
	
	self assert: sut subdirectories size = 1.
	self assert: (sut subdirectories includes: expectedSVNSubDirectory).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testRecursiveReadOnlyWithFiles

	| fileName content pathToFile expectedSvnFile |
	"Create real directory"
	self
		createDirNamed: sut theName
		in: sut basePath.
	"Create a file"
	fileName := 'someFile'.
	content := 'blupfi'.
	pathToFile := self pathTo: fileName inDir: sut path.
	self inFile: pathToFile write: content.
	"Create SVNFile equivalent"
	expectedSvnFile := SVNFile 
		named: fileName
		basePath: sut path
		content: content.
	"exercise"
	sut read.
	self assert: (sut files includes: expectedSvnFile)! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rt 3/14/2008 15:46'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut remove.
	
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testStoreDirectory

	sut store.
	self
		assertThatDirectories: {sut theName}
		existsIn: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreDirectoryWithFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreLotsOfDirectoriesAndFiles

	| fileName subDirName subDirFileName subSubDirName subSubDirFileName subDir subSubDir |
	self willTouchFileSystem.
	fileName := 'file'.
	subDirName := 'subDir'.
	subDirFileName := 'subDirFileName'.
	subSubDirName := 'subsubDir'.
	subSubDirFileName := 'subSubDirFileName'.

	sut createFileNamed: fileName.
	subDir := sut createSubDirectoryNamed: subDirName.
	subDir createFileNamed: subDirFileName.
	subSubDir := subDir createSubDirectoryNamed: subSubDirName.
	subSubDir createFileNamed: subSubDirFileName.
	
	sut store.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	self assertThatFiles: {subDirFileName. subSubDirName} existsIn: subDir path.
	self assertThatFiles: {subSubDirFileName} existsIn: subSubDir path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:10'!
testStoreProperties

	| propertyDict result |
	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
		named: 'bla2'
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self svnClientDo: [:svnClient |
		result := svnClient svnGetPropertiesFrom: sut path].
	self assert: propertyDict = result.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:59'!
testSubdirectoriesMustHaveTheCorrectBasePath01

	| newDir |
	newDir := SVNDirectory
		named: 'blupf'
		basePath: 'not/existing/path'.
	sut addSubdirectory: newDir.
	self assert: newDir basePath = sut path.! !

SVNTestCase subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'assertion' stamp: 'rkrk 2/27/2008 02:00'!
assertThatProperties: propertyDict areAddedTo: svnDirectoryEntry

	| client |
	client := SVNCApiClient new.
	self assert: (propertyDict = (client svnGetPropertiesFrom: svnDirectoryEntry path)).! !

!SVNFileTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNFile
		named: 'SVNFileCreatedDuringTests'
		basePath: self pathForTests.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:50'!
testCommitARemovedFile
	| client fileName |
	"create"
	client := SVNCApiClient new.
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile named: fileName basePath: self workingCopyPath.
	sut store.
	client svnAdd: sut path.
	client svnCommit: {  (sut path)}.
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self assert: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName).
	
	"remove"
	sut remove.
	client svnCommit: {sut path}.
	
	"check"
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self deny: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:50'!
testConvertIllegalFileName01

	| expected separator |
	sut theName: 'selectorwithcolon:'.
	separator := sut class asciiValueSeparator asString.
	expected := 'selectorwithcolon' , separator , $: asciiValue asString , separator.
	self assert: sut filename = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:54'!
testConvertIllegalFileName02

	| expected firstPart separator |
	sut theName: '//'.
	separator := sut class asciiValueSeparator asString.
	firstPart := separator , $/ asciiValue asString , separator.
	expected := firstPart , firstPart.
	self assert: sut filename = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/12/2008 14:51'!
testCreateMethodWithAsciiInName

	| separator |
	separator := sut class asciiValueSeparator asString.
	sut := SVNFile
		named: 'm1' , separator , '58' , separator
		basePath: self pathForTests.
	self assert: sut theName = 'm1:'.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:12'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	sut delete.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:14'!
testDeletenonExistingFile

	| fileName |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self shouldnt: [sut delete] raise: Error.
! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/5/2008 20:22'!
testEqualFilesStoredInSet

	| fileName content file1 file2 assoc set dir |
	self willTouchFileSystem.
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 store.
	dir := self defaultSVNDirectory.
	dir read.
	dir commit.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	set := Set with: file1 with: file2.
	self assert: set size = 1.
	self assert: file1 = file2.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:34'!
testEquals

	| fileName content file1 file2 assoc |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	self assert: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:52'!
testEquals02

	| file1 file2 set |
	file1 := SVNFile readFrom:  '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	file2 := SVNFile readFrom: '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	set := Set with: file1 with: file2.
	self assert: set size = 1.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/4/2008 01:11'!
testReadFileContents

	| fileName content fullPath |
	self willTouchFileSystem.
	fileName := 'someSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self pathTo: fileName inDir: self pathForTests.
	self 
		inFile: fullPath
		write: content.
	sut read.
	self assert: sut content = content! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/4/2008 01:22'!
testReadFileProperties

	| fileName helper expected propertyKey propertyValue |
	self willNeedRepositoryAndWorkingCopy.
	"create some file and add manually properties to it"
	fileName := 'someSVNFile'.
	helper := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	helper store.	
	propertyKey := 'schluessel'.
	propertyValue := 'wert'.
	self svnClientDo: [:svnClient |
		svnClient svnAddProperty: propertyKey WithValue: propertyValue To: helper path].
	
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut read.
	expected := Dictionary with: propertyKey -> propertyValue.
	self assert: sut properties = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/5/2008 18:52'!
testReadMethodWithIllegalFileName01

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named:  'm1:'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNFile
		named: svnFile theName
		basePath: svnFile basePath.
	sut read.
	self assert: sut = svnFile.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 2/27/2008 01:37'!
testReadNonExistingFile

	| fileName |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self should: [sut read] raise: Error .! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:51'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'aLittleSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut remove.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:20'!
testStoreAndAddFile

	| fileName |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'testSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut store.
	self 
		assertFile: fileName
		wasSVNAddedIn: self workingCopyPath! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:57'!
testStoreAsFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreContent

	| fileName content |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreProperties

	| fileName propertyDict |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self
		assertThatProperties: propertyDict
		areAddedTo: sut.! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/13/2008 15:26'!
testSvnAdd

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNFile
		named: 'FileName'
		basePath: self workingCopyPath.
	sut
		store;
		svnAdd.
	self
		assertFile: sut theName
		wasSVNAddedIn: sut basePath.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:30'!
testUnequal01

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content , ' Blupf'.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:31'!
testUnequal02

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName , ' abc'
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:33'!
testUnequal03

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 properties add: 'key' -> 'value'.
	file2 properties add: 'otherKey' -> 'value'.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/14/2008 04:19'!
testUpdateWithNoLocalChanges

	| contentForRev1 |
	self willNeedRepositoryAndWorkingCopy.
	contentForRev1 := 'abc'.
	sut content: contentForRev1.
	sut
		store;
		commit.
	"self assert: false."! !

SVNTestCase subclass: #SVNLoaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNLoaderTest methodsFor: 'assertions' stamp: 'rt 3/7/2008 22:07'!
classesRecoveredCorrect: aSet

	| element setUnderTest |
	self assert: aSet size = 1.
	element := aSet someElement.
	self assert: element superclassName = 'Object'.
	self assert: element theName = 'TestClass4'.
	
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass3'. 'TestClass5'} asSet.
	self assert: (setUnderTest detect: [:each | each theName = 'TestClass5']) subclasses isEmpty.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass3'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 1.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass2'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass1'. 'TestClass6'} asSet.
	
	setUnderTest do: [:each | self assert: each subclasses isEmpty].
	^true! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 10:52'!
getSVNTestClassFromClass: aClass

	^SVNClass forExistingClass: aClass! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:45'!
getTestClass

	| class |
	class :=(Smalltalk classNamed: self nameOfTestClass asSymbol) ifNil: [Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: '' 
		classVariableNames:''
		poolDictionaries: ''
		category: self class category asString].
	
	class
		compile: 'm1: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm2: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm3: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	^class! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 23:21'!
nameOfTestClass

	^'ClassOfSVNLoaderTest'! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 11:21'!
removeTestClass: name

	| class |
	(class := Smalltalk classNamed: name) ifNotNil: [class removeFromSystem].! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:29'!
setOfDependentClasses
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'SVNMethod')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'SVNClass')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'DoesNotExistingClass').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 15:58'!
setOfDependentClassesWithCycles
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass1').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 21:08'!
setOfDependentClassesWithOutCycles

	^Set with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'TestClass2').! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/8/2008 02:43'!
setUp
	super setUp.
	sut := SVNLoader new! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/7/2008 11:16'!
tearDown

	self removeTestClass: self nameOfTestClass.
	
	super tearDown! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 22:29'!
testClassSorting

	| aSVNClassSet sortedSVNClasses |
	aSVNClassSet := self setOfDependentClassesWithOutCycles.
	sut addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	
	sortedSVNClasses := sut sortSVNClasses: aSVNClassSet consider: (sut requiredClasses intersection: sut classesToLoad).
	
	self assert: (self classesRecoveredCorrect: sortedSVNClasses)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 12:53'!
testDetectDependenciesInSVNClasses

	| resultSet |
	resultSet := sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses..
	self assert: resultSet = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/8/2008 22:39'!
testDetectDependenciesInSVNMethods

	| svnClass resultSet |
	svnClass := self getSVNTestClassFromClass: self getTestClass.
	resultSet := sut 
				addToRequiredClassesAllDependenciesInSVNMethods: (svnClass versionedMethods).
	self assert: resultSet = (Set with: self nameOfTestClass)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 16:08'!
testForCycles

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithCycles.
	self assert: (sut hasCycle: self setOfDependentClassesWithCycles).
	
	sut initialize.
	
	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithOutCycles.
	self deny: (sut hasCycle: self setOfDependentClassesWithOutCycles).! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 15:56'!
testRequirements

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses.
	
	self assert: sut classesToLoad = {'TestClass1'. 'TestClass2'. 'TestClass3'. 'TestClass4'. 'TestClass5'. 'TestClass6'} asSet.
	
	self assert: sut requiredClasses = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet.
	
	self assert: sut unknownRequiredClasses = {'DoesNotExistingClass'} asSet! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:25'!
testEquals

	| methodBlock method1 method2 |
	methodBlock := [SVNMethod forExistingMethod: self svnDummy >> #m1].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 12:44'!
testExtractMetaClass

	| method result svnFile className |
	method := SVNMethod new.
	self flag: #TODO. "Implicitly specified mapping..."
	svnFile := SVNFile
		named: 'm99'
		basePath: '/'.
	className := 'SVNDummy class'.
	svnFile properties
		at: 'class'
		put: className.
	result := method extractClassFrom: svnFile.
	self assert: result = className.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 3/4/2008 03:25'!
testLoadMethodIntoSystem

	| class methodSelector  |
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	class removeSelector: methodSelector.
	self deny: (class methodDict includesKey: methodSelector).
	sut load.
	self assert: (class methodDict includesKey: methodSelector).! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 3/4/2008 03:25'!
testRestoreFromSVNFile

	
	| methodSelector class methodReference svnFile expectedSVNMethod |
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	methodReference := (class >> methodSelector) methodReference.
	svnFile := SVNFile 
		named: methodSelector asString
		basePath: ''
		content: methodReference source.
	svnFile properties 
		at: 'class'
		put: class name asString.
	svnFile properties 
		at: 'category'
		put: methodReference category.
	svnFile properties 
		at: 'timestamp'
		put: methodReference timeStamp.
	"exercise"
	sut := SVNMethod restoreFrom: svnFile.
	"expected"
	expectedSVNMethod := SVNMethod forExistingMethod: class >> methodSelector.
	"assertion"
	self assert: sut = expectedSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 3/5/2008 18:20'!
testStoreInSVNDirectory
	
	| svnDir methodFile methodSelector class methodReference expectedSVNFile |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	svnDir := self defaultSVNDirectory.
	"exercise"
	sut storeIn: svnDir.
	"expected"
	methodReference := (class >> methodSelector) methodReference.
	expectedSVNFile := SVNFile 
		named: methodSelector asString
		basePath: svnDir path
		content: methodReference source.
	expectedSVNFile properties 
		at: 'class'
		put: class name asString.
	expectedSVNFile properties 
		at: 'category'
		put: methodReference category.
	expectedSVNFile properties 
		at: 'timestamp'
		put: methodReference timeStamp.
	"assertion"
	methodFile := svnDir getFileNamed: sut theName.
	self assert: methodFile notNil.
	self assert: methodFile = expectedSVNFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 3/4/2008 03:26'!
testStoreThenRestore

	| methodName writtenSVNMethod svnDirectory methodFile readSVNMethod |
	self willTouchFileSystem.
	"prepare"
	methodName := 'm1'.
	writtenSVNMethod := SVNMethod forExistingMethod: self svnDummy >> methodName asSymbol.
	svnDirectory := self defaultSVNDirectory.
	"exercise"
	writtenSVNMethod storeIn: svnDirectory.
	"assertion"
	methodFile := svnDirectory getFileNamed: methodName.
	self assert: methodFile notNil.
	readSVNMethod := SVNMethod restoreFrom: methodFile.
	self assert: writtenSVNMethod = readSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 3/12/2008 14:52'!
testStoreWithSpecialCharInSVNDirectory

	"prepare"
	| svnDir methodFile methodSelector class expectedFileName separator |
	methodSelector := #<.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	svnDir := self defaultSVNDirectory.
	"exercise"
	sut storeIn: svnDir.
	"expected"
	separator := SVNDirectoryEntry asciiValueSeparator asString.
	expectedFileName := separator , '60' , separator.
	"assertion"
	methodFile := svnDir getFileNamed: sut theName.
	self assert: methodFile notNil.
	self assert: methodFile filename = expectedFileName! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNProjectTest subclass: #SVNProjectExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectExternalTest methodsFor: 'assertions' stamp: 'rkrk 3/6/2008 14:41'!
assertNoSVNFileWithIllegalCharacterIn: aSVNDirectory

	aSVNDirectory files do: [:each |
		self assert: (each filename includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not.].
	aSVNDirectory subdirectories do: [:each | self assertNoSVNFileWithIllegalCharacterIn: each].! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/14/2008 18:15'!
createSimpleDummyClassForSVNProjectTest

	| class |
	class := Object
				subclass: self nameOfClassForTests asSymbol
				instanceVariableNames: 'oo'
				classVariableNames: 'Fl'
				poolDictionaries: ''
				category: self class category asString.
	
	class compile: 'm1: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm2: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm3: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm4: obj' classified: 'neu' withStamp: nil notifying: nil.
	^class! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/13/2008 16:32'!
nameOfClassForTests

	^ 'SimpleDummyClassForSVNProjectTest'! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/13/2008 17:06'!
removeSimpleDummyClassForSVNProjectTest
	(Smalltalk hasClassNamed: self nameOfClassForTests) ifFalse: [^self].
	(Smalltalk classNamed: self nameOfClassForTests) removeFromSystem! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:34'!
setUp

	super setUp.
	
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	self createSimpleDummyClassForSVNProjectTest.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:35'!
tearDown

	self removeSimpleDummyClassForSVNProjectTest.
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	
	super tearDown.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:37'!
testCheckoutProperties

	| svnPro destination client |
	self willNeedRepositoryAndWorkingCopy.

	svnPro := SVNProject
 		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
     
	svnPro addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro store.

	destination := self workingCopyPath, self slash, svnPro theName,
				self slash, self nameOfClassForTests.
	client := SVNCommandLineClient new.
	client
		svnAddProperty: 'instanceVariables'
		WithValue: 'instVar1'
		To: destination.

	svnPro projectDirectory read.
	self assert: (svnPro projectDirectory subdirectories size = 1).! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 3/13/2008 16:36'!
testCheckoutSVNDirectories

	| svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 workingCopyDirectory.
	svnPro1 commit.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 workingCopyDirectory.
	svnPro1 checkout.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 workingCopyDirectory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 3/14/2008 19:40'!
testCountOfCommitedElements

	| svnPro1 svnPro2 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	
	svnPro2 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	
	svnPro1 commit.
	svnPro1 commit.
	self assert: svnPro1 = svnPro2.

	self assert: svnPro1 projectDirectory subdirectories size = 1.
	self assert: svnPro1 projectDirectory subdirectories size = svnPro2 projectDirectory subdirectories size.
	self assert: svnPro1 projectDirectory subdirectories someElement files size = svnPro2 projectDirectory subdirectories someElement files size.
	self assert: svnPro1 projectDirectory subdirectories someElement subdirectories size = svnPro2 projectDirectory subdirectories someElement subdirectories size.
	self assert: ((svnPro1
					projectDirectory subdirectories someElement subdirectories
						detect: [:each | each theName = 'instance']) files size
							= (svnPro2 projectDirectory subdirectories someElement subdirectories
								detect: [:each | each theName = 'instance']) files size)! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 3/13/2008 16:38'!
testCountOfCommitedElements02

	| svnPro1 svnPro2 projectName |
	self willTouchFileSystem. self flag: #TODO. "No need to write to disk..."
	projectName := 'TestPro'.
	
	svnPro1 := SVNProject named: projectName.
	svnPro1 workingCopyDirectory: (SVNDirectory on: self pathForTests).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 store.
	
	svnPro2 := SVNProject named: projectName.
	svnPro2 workingCopyDirectory: (SVNDirectory on: self pathForTests).
	svnPro2 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro2 store.
	
	svnPro1 store.
	svnPro1 store.
	"self assert: svnPro1 = svnPro2."
	self assert: svnPro1 workingCopyDirectory = svnPro2 workingCopyDirectory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:48'!
testDeleteAClass

	| projectName svnProject svnClass secondWorkingCopyPath sameProject |
	"Was this test not a bit too complicated?"
	self willNeedRepositoryAndWorkingCopy.
	self flag: #TODO.
	projectName := 'TestPro'.
	svnProject := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath "There was repositoryPath...?"
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	svnClass := SVNClass forExistingClass: self createSimpleDummyClassForSVNProjectTest.
	svnProject
		addSVNClass: svnClass;
		commit;
		removeSVNClass: svnClass;	"exercise"
		commit.
	
	"Is the class really deleted?"
	secondWorkingCopyPath := self workingCopyPath, '2'.

	sameProject := SVNProject
		checkoutProject: projectName
		fromURL: self repositoryURLPath
		inWorkingCopy:  (SVNDirectory on: secondWorkingCopyPath).
	self assert: sameProject versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 03:57'!
testStoringOfInstanceVariables

	| class svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	svnPro1 checkout.
	svnPro1 load.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i1 i2'.
	svnPro1 commit.
	class := nil.
	"self halt."
	svnPro1 checkout.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i3'.
	svnPro1 commit.
	svnPro1 checkout.! !

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 02:08'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject theName).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 3/14/2008 15:06'!
testAddClass

	| aClass methodsOfClass result |
	sut := SVNProject named: 'TestPro'.
	sut workingCopyDirectory: self defaultSVNDirectory.
	aClass := SVNDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: aClass)).
	methodsOfClass := (aClass methodDict collect: [:ea | SVNMethod forExistingMethod: ea ])
						union: (aClass class methodDict collect: [:ea | SVNMethod forExistingMethod: ea ]).
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 3/13/2008 14:09'!
testAddClassWhenClassAlreadyExist

	| aClass svnClass svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut workingCopyDirectory: self defaultSVNDirectory.
	aClass := self svnDummy.
	sut addClass: aClass.
	svnClass := SVNClass forExistingClass: aClass.
	svnMethod := svnClass versionedMethods detect: [:ea | (ea theName = 'm2') and: [ea nameOfClass asSymbol = svnClass theName]].
	svnClass removeSVNMethod: svnMethod.
	sut addSVNClass: svnClass.
	self assert: sut versionedClasses size = 1.
	self assert: (sut versionedClasses someElement versionedMethods noneSatisfy: [:ea | ea theName = 'm2']).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 3/14/2008 15:07'!
testAddMethod

	| aMethod svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut workingCopyDirectory: self defaultSVNDirectory.
	aMethod := self svnDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod nameOfClass = aMethod methodReference actualClass name.
	self assert: svnMethod methodSelector = aMethod selector! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 04:52'!
testMappingToFileSystem01

	self willTouchFileSystem.
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut workingCopyDirectory: self defaultSVNDirectory.
	sut store.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 3/13/2008 13:53'!
testRemoveClass

	| svnClass |	
	sut := SVNProject named: 'test'.
	sut workingCopyDirectory: self defaultSVNDirectory.
	svnClass := SVNClass forExistingClass: SVNDummy.
	sut addSVNClass: svnClass.
	self assert: (sut versionedClasses includes: svnClass).
	sut removeSVNClass: svnClass.
	self deny: (sut versionedClasses includes: svnClass).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 3/14/2008 13:56'!
testRestore

	| directory projectName class storedProject |
	"self willTouchFileSystem."
	directory := self defaultSVNDirectory.
	projectName := 'SomeSVNProject'.
	class := self svnDummy.
	storedProject := SVNProject named: projectName.
	storedProject workingCopyDirectory: directory.
	storedProject addClass: class.
	storedProject storeIn: directory.
	
	sut := SVNProject restoreFrom: (directory getSubDirectoryNamed: projectName).
	self assert: sut theName = projectName.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: class)).! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 3/15/2008 05:30'!
assertFile: fileName wasSVNAddedIn: path 

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: path , self slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName)! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatDirectories: dirNames existsIn: path

	dirNames do: [:each |
		self assert: ((FileDirectory on: path) directoryExists: each)] .! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/24/2008 23:48'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent 

	| fullPath actualContent |
	fullPath := self pathTo: fileName inDir: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 01:29'!
assertThatFiles: fileNames existsIn: path

	| dir |
	fileNames do: [:each |
		dir := FileDirectory on: path.
		self assert: ((dir fileExists: each) or: [(dir directoryExists: each)])] .! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/4/2008 03:07'!
cleanupSVNDummy

	self hasModifiedSVNDummy ifFalse: [^ self].
	self flag: #TODO. "Full restore?"
	self svnDummy methodDict
		at: #m2 
		ifAbsent: [self svnDummy compile: self sourceCodeForSVNDummyM2]! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 01:54'!
createDirNamed: newDirName in: existingDir 
	
	(FileDirectory on: existingDir) assureExistenceOfPath: newDirName.
	^ existingDir , FileDirectory slash , newDirName.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 02:30'!
defaultSVNDirectory
	
	^ SVNDirectory on: self pathForTests! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager
	^ directoryManager! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager: anObject
	directoryManager := anObject! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy
	^ hasModifiedSVNDummy! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy: anObject
	hasModifiedSVNDummy := anObject! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 02:53'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.! !

!SVNTestCase methodsFor: 'initialization' stamp: 'rkrk 3/15/2008 04:21'!
initialize

	super initialize.
	self slash: FileDirectory slash.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:53'!
pathForTests

	^ self directoryManager pathForTests.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/24/2008 23:45'!
pathTo: filename inDir: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:54'!
repositoryURLPath

	^ self directoryManager repositoryURLPath! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/14/2008 02:34'!
restoreSVNDummy

	"Read a file out of SVNDummy. If you change the class, replace this fileout."
	| stream |
	stream :=  ReadWriteStream with: '''From Squeak3.9 of 7 November 2006 [latest update: #7067] on 23 February 2008 at 11:10:05 pm''!!
Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	poolDictionaries: ''''
	category: ''SqueakSVN-Base-Test''!!
!!SVNDummy commentStamp: ''<historical>'' prior: 0!!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 3/14/2008 02:25''!!
< other

	^ super < other!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''test 2/23/2008 11:54''!!
m1
	^ 1!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''timestamp''!!
m2
	^ 2!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''cop 2/7/2008 19:50''!!
methodWithSpecialCharacter: aString
	^ aString!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

SVNDummy class
	instanceVariableNames: ''IC1 IC2''!!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''cop 2/7/2008 19:50''!!
m3

	^ 3!! !!


!!SVNDummy class methodsFor: ''convenience'' stamp: ''cop 2/7/2008 19:50''!!
sourceCodeForM2
	^ ''m2
	^ 2''!! !!
'.
	stream
		reset;
		fileInAnnouncing: 'Restoring SVNDummy';
		close.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/16/2008 02:57'!
setUp

	"[SVNTestDirectoryManager instance: nil]"
	super setUp.
	self hasModifiedSVNDummy: false.
	self directoryManager: SVNTestDirectoryManager getInstance.
	self directoryManager testDirectories ifEmpty: [
		self directoryManager
			basePath: (FileDirectory default directoryNamed: 'svnTests') pathName;
			createBasicTestDirs: 200 svnAwareTestDirs: 50]! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 04:22'!
slash

	^ slash! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:23'!
slash: string

	slash := string! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:01'!
sourceCodeForSVNDummyM2

	^ 'm2
	^ 2'! !

!SVNTestCase methodsFor: 'svn helper' stamp: 'rkrk 3/4/2008 00:58'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:07'!
svnDummy

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy'.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'mu 3/4/2008 11:20'!
svnDummy99

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy99'.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/15/2008 02:32'!
tearDown

	super tearDown.
	self
		"cleanupFileSystem;"
		cleanupSVNDummy.
	self directoryManager unregister.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/4/2008 02:29'!
willModifySVNDummy

	self hasModifiedSVNDummy: true.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/15/2008 01:56'!
willNeedRepositoryAndWorkingCopy

	self directoryManager registerForSvnAwareTestDirectory.! !

!SVNTestCase methodsFor: 'running' stamp: 'test 3/16/2008 03:02'!
willTouchFileSystem
	
	self flag: #TODO.
	self directoryManager registerForTestDirectory.
	"do nothing? directoryManager already has a new
	current directory because of #unregister"
	"self directoryManager registerForTestDirectory."! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'test 3/15/2008 04:34'!
workingCopyPath

	^ self directoryManager workingCopyPath! !

TestCase subclass: #SVNTestDirectoryManagerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNTestDirectoryManagerTest methodsFor: 'default' stamp: 'rkrk 3/15/2008 00:27'!
pathForManager

	^ (FileDirectory default directoryNamed: 'TestManagerTestDir') pathName! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:33'!
setUp
	super setUp.
	"SVNTestDirectoryManager is a singleton. For tests get own copy"
	sut := SVNTestDirectoryManager basicNew initialize.
	sut basePath: self pathForManager.! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:34'!
tearDown
	
	super tearDown.
	sut clear.
	(FileDirectory on: self pathForManager) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:58'!
testAfterRegisterAnswerSameDirectory

	| directory |
	sut
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	sut registerForTestDirectory.
	directory := sut currentDirectory.
	self assert: directory notNil.
	self assert: sut pathForTests = directory pathForTests.
	self assert: sut currentDirectory == directory.
	sut unregister.
	self deny: sut currentDirectory == directory.
	"self should: [sut pathForTests] raise: AssertionFailure"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:59'!
testCallingSvnAwareMethods

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 3.
	sut registerForSvnAwareTestDirectory.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:01'!
testCallingSvnAwareMethodsWithoutProperRegisteringShouldFail

	sut
		createBasicTestDirs: 2
		svnAwareTestDirs: 1.
	sut registerForTestDirectory.
	self should: [sut workingCopyPath] raise: AssertionFailure.
	self should: [sut repositoryURLPath] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 06:28'!
testCreateAgainShouldUseAlreadyExistingDirectories

	| someElement |
	sut 
		createBasicTestDirs: 3
		svnAwareTestDirs: 0.
	someElement := sut testDirectories anyOne.
	sut 
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	self assert: sut basicTestDirectories size = 5.
	self assert: (sut testDirectories includes: someElement).! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 05:23'!
testPercent

	self assert: (sut percent: 30 of: 80) = 24.
	self assert: (sut percent: 10 of: 3) = 1. "At least be one"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:32'!
testRecreate10Percent

	sut 
		createBasicTestDirs: 10
		svnAwareTestDirs: 0.
	5 timesRepeat: [
		sut registerForTestDirectory.
		sut currentDirectory isDirty: true.
		sut unregister].
	sut reCreatePercent: 10.
	self assert: (sut testDirectories count: [:ea | ea isDirty not]) = 6.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:02'!
testRegisteringMoreOftenThanTheDefaultNumberOfPreparedDirectories

	| numberOfTimesToRegister |
	sut createBasicTestDirs: 5 svnAwareTestDirs: 0.
	numberOfTimesToRegister := sut basicTestDirectories size + 3.
	numberOfTimesToRegister timesRepeat: [
		sut registerForTestDirectory.
		self deny: sut currentDirectory isDirty.
		sut currentDirectory isDirty: true.
		sut unregister].! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'test 3/16/2008 06:16'!
testShouldClearOldDirectories

	| sutFileDirectory |
	sut 
		createBasicTestDirs: 20
		svnAwareTestDirs: 0.
	sutFileDirectory := FileDirectory on: sut basePath.
	self assert: sutFileDirectory entries size = 20.
	sut 
		createBasicTestDirs: 12
		svnAwareTestDirs: 0.
	self assert: sutFileDirectory entries size = 12.! !

TestCase subclass: #SVNTestDirectoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

SVNTestDirectoryTest subclass: #SVNAwareTestDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNAwareTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 20:52'!
setUp
	super setUp.
	sut := SVNAwareTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:24'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:11'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut workingCopyDirectory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut repositoryDirectory exists.
	self deny: sut workingCopyDirectory exists.
	self deny: sut directory exists.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:48'!
testCreateInBasepath

	| directory |
	sut create.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self assert: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:56'!
testPathForTestIsWorkingCopyPath

	self assert: sut pathForTests = sut workingCopyPath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:07'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:55'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/15/2008 15:57'!
setUp

	super setUp.
	sut := SVNTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNTestDirectoryTest methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:09'!
somePath

	| localName dir |
	localName := 'forSVNTestDirectoryTest'.
	dir := FileDirectory default.
	dir assureExistenceOfPath: localName.
	^ dir pathName , dir slash , localName.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:25'!
tearDown

	super tearDown.
	self flag: #TODO.
	(FileDirectory on: self somePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut directory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testCreateInBasepath

	sut create.
	self deny: sut isDirty.
	self assert: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:05'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:54'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

Model subclass: #SVNCommitBrowser
	instanceVariableNames: 'browserMorph comment element widget builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNCommitBrowser class methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:17'!
openWith: svnElement
	| instance |			
	instance := (self new) element: svnElement.
	self halt.
	ToolBuilder default open: instance.
	^instance! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'mu 3/2/2008 18:29'!
alwaysTrue
	^true! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'rkrk 3/4/2008 07:15'!
buildWith: aBuilder 
	| windowSpec treeSpec commitButton commentSpec cancelButton |
	builder := aBuilder.
	windowSpec := (aBuilder pluggableWindowSpec new)
				extent: 400 @ 300;
				model: self;
				label: 'SqueakSVN Commit Browser';
				closeAction: #closeWindow;
				children: OrderedCollection new.
				
	commentSpec := (aBuilder pluggableInputFieldSpec new)
				model: self;
				getText: #comment;
				setText: #setComment:;
				frame: (0 @ 0 corner: 1 @ 0.5).
				
	"recentMessagesButton := (aBuilder pluggableButtonSpec new)
				model: self;
				label: #recentMessagesButtonLabel;
				action: #cancel;
				color: #grayColor;
				state: #alwaysTrue;
				frame: (0.4 @ 0.4 corner: 0.6 @ 0.5)."
				
	treeSpec := (aBuilder pluggableTreeSpec new)
				"model: self;
				roots: #listOfProjectNodes;
				hasChildren: #nodeHasChildren:;
				getChildren: #getChildrenOfNode:;
				label: #labelOfNode:;
				menu: #menuOn:;
				getSelectedPath: #getPathToSelectedNode;
				setSelected: #setSelectedNode:;"
				frame: (0 @ 0.5 corner: 1 @ 0.9).
				
	commitButton := (aBuilder pluggableButtonSpec new)
				model: self;
				label: #commitButtonLabel;
				action: #commit;
				color: #grayColor;
				state: #alwaysTrue;
				frame: (0.3 @ 0.9 corner: 0.5 @ 1).
				
	cancelButton := (aBuilder pluggableButtonSpec new)
				model: self;
				label: #cancelButtonLabel;
				action: #cancel;
				color: #grayColor;
				state: #alwaysTrue;
				frame: (0.5 @ 0.9 corner: 0.7 @ 1).
				
	windowSpec children add: commentSpec.
	"windowSpec children add: recentMessagesButton."
	windowSpec children add: treeSpec.
	windowSpec children add: commitButton.
	windowSpec children add: cancelButton.
	self flag: #TODO.
	widget := aBuilder build: windowSpec.
	^ widget! !

!SVNCommitBrowser methodsFor: 'functionality' stamp: 'rt 3/10/2008 12:45'!
cancel
	self close! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'mu 3/2/2008 20:18'!
cancelButtonLabel
	^'Cancel'! !

!SVNCommitBrowser methodsFor: 'functionality' stamp: 'rt 3/10/2008 12:45'!
close
	builder close: widget! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'mu 3/2/2008 22:21'!
closeWindow
	widget := nil.! !

!SVNCommitBrowser methodsFor: 'functionality' stamp: 'rt 3/10/2008 12:50'!
comment
	^ comment ifNil: ['Enter a comment']! !

!SVNCommitBrowser methodsFor: 'functionality' stamp: 'pe 3/3/2008 12:37'!
comment: aString
	comment := aString.! !

!SVNCommitBrowser methodsFor: 'functionality' stamp: 'rt 3/10/2008 12:45'!
commit
	self element commitWithMessage: self comment..
	SVNCommitMessage openWith: self comment.
	self close.! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'mu 3/2/2008 20:16'!
commitButtonLabel
	^'Commit'! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'pe 3/3/2008 11:32'!
element
	^ element! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'pe 3/3/2008 11:32'!
element: anObject
	element := anObject! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'mu 3/13/2008 14:41'!
grayColor
	^ Color gray! !

!SVNCommitBrowser methodsFor: 'ui' stamp: 'mu 3/2/2008 20:26'!
recentMessagesButtonLabel
	^'Recent messages'! !

!SVNCommitBrowser methodsFor: 'functionality' stamp: 'rt 3/10/2008 12:48'!
setComment: aText
	self comment: aText asString.
	^true.! !

Model subclass: #SVNCommitMessage
	instanceVariableNames: 'comment builder widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNCommitMessage class methodsFor: 'as yet unclassified' stamp: 'pe 3/3/2008 13:12'!
openWith: aString
	| instance |			
	instance := (self new) comment: aString.
	ToolBuilder default open: instance.
	^instance! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:32'!
alwaysTrue
	^ true! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:46'!
blueColor
	^ Color blue lighter lighter  ! !

!SVNCommitMessage methodsFor: 'ui' stamp: 'mu 3/13/2008 15:03'!
buildWith: aBuilder 
	| windowSpec commentSpec okButton |
	builder := aBuilder.
	windowSpec := (aBuilder pluggableWindowSpec new)
				extent: 320 @ 180;
				model: self;
				label: 'SqueakSVN Commit Message';
				closeAction: #closeWindow;
				children: OrderedCollection new.
				
	commentSpec := (aBuilder pluggableInputFieldSpec new)
				model: self;
				getText: #logMessage;
				frame: (0 @ 0 corner: 1 @ 0.75).
				
				
	okButton := (aBuilder pluggableButtonSpec new)
				model: self;
				label: #okButtonLabel;
				action: #ok;
				color: #grayColor;
				state: #alwaysTrue;
				frame: (0.3 @ 0.75 corner: 0.7 @ 1).
				
	windowSpec children add: commentSpec.
	windowSpec children add: okButton.
	widget := aBuilder build: windowSpec.
	^ widget! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:34'!
close
	builder close: widget! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:33'!
closeWindow
	widget := nil.! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:26'!
comment
	^ comment! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:26'!
comment: aString
	comment := aString! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 14:55'!
grayColor
	^ Color gray  ! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'mu 3/13/2008 15:16'!
logMessage
	| logMessage |
	logMessage := 
		('Commit was successful' asText) allBold, 
		String cr,
		String cr,
		('Comment:' asText) allBold,
		String tab,
		self comment,
		String cr,
		String cr,
		('Timestamp:' asText) allBold,
		String tab,
		"nicht schn, da nicht die Zeit von der Version sondern aktuelle Zeit"
		TimeStamp current asString.
	^ logMessage! !

!SVNCommitMessage methodsFor: 'as yet unclassified' stamp: 'pe 3/3/2008 13:09'!
ok
	builder close: widget! !

!SVNCommitMessage methodsFor: 'ui' stamp: 'mu 3/13/2008 14:32'!
okButtonLabel
	^ 'Ok'! !

Model subclass: #SVNCreateProjectDialog
	instanceVariableNames: 'theName url builder widget workingCopyPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNCreateProjectDialog class methodsFor: 'as yet unclassified' stamp: 'cop 2/26/2008 14:04'!
open
	| instance |			
	instance := self new.
	ToolBuilder default open: instance.
	^instance! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'rt 3/3/2008 12:39'!
buildWith: aBuilder

	| windowSpec okButton cancelButton nameField urlField wcField |
	self builder: aBuilder.
	windowSpec := (self builder pluggableWindowSpec new)
				extent: 300 @ 180;
				model: self;
				label: 'Create a SVNProject';
				children: OrderedCollection new.
				
	nameField := (self builder pluggableInputFieldSpec new)
				model: self;
				getText: #theName;
				setText: #setTheName:;
				frame: (0 @ 0 corner: 1 @ 0.266).
				
	urlField := (self builder pluggableInputFieldSpec new)
				model: self;
				getText: #url;
				setText: #setUrl:;
				frame: (0 @ 0.266 corner: 1 @ 0.533).
				
	wcField := (self builder pluggableInputFieldSpec new)
				model: self;
				getText: #workingCopyPath;
				setText: #setWorkingCopyPath:;
				frame: (0 @ 0.533 corner: 1 @ 0.8).
				
	okButton := (self builder pluggableButtonSpec new)
				model: self;
				label: #okButtonLabel;
				action: #createProject;
				color: #greenColor;
				state: #canAccept;
				frame: (0 @ 0.8 corner: 0.5 @ 1).
				
	cancelButton := (self builder pluggableButtonSpec new)
				model: self;
				label: #cancelButtonLabel;
				action: #close;
				color: #redColor;
				frame: (0.5 @ 0.8 corner: 1 @ 1).
				
	windowSpec children
		add: nameField;
		add: urlField;
		add: wcField;
		add: okButton;
		add: cancelButton.
	windowSpec frame: (0 @ 0 corner: 1 @ 1).
	self widget: (self builder build: windowSpec).
	^ self widget! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:21'!
builder

	^ builder! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:21'!
builder: aBuilder

	builder := aBuilder! !

!SVNCreateProjectDialog methodsFor: 'functionality' stamp: 'rkrk 3/3/2008 20:41'!
canAccept

	^ self theName ~= self defaultName and:
		[self url ~= self defaultURL] and:
		[self workingCopyPath ~= self defaultWCPath].! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'rkrk 3/3/2008 11:24'!
cancelButtonLabel

	^'Cancel'! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'rkrk 3/3/2008 11:06'!
close
	
	self builder close: self widget! !

!SVNCreateProjectDialog methodsFor: 'functionality' stamp: 'rkrk 3/4/2008 10:02'!
createProject

	| aSVNProject |
	self canAccept ifFalse: [^nil].
	aSVNProject := SVNProject
		checkoutProject: self theName
		fromURL: self url
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	aSVNProject load.
	self changed: #newProject with: aSVNProject.
	self close.! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 3/3/2008 11:14'!
defaultName

	^'Insert the project name here.'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 3/3/2008 11:14'!
defaultURL

	^'Insert the repository URL here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 3/3/2008 11:15'!
defaultWCPath

	^'Insert the working copy path here'! !

!SVNCreateProjectDialog methodsFor: 'converting' stamp: 'rt 3/3/2008 12:41'!
getFullPathFor: aString

	aString asString asURI isAbsolute ifTrue: [^aString].
	^FileDirectory fullPathForURI: aString! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'rkrk 3/3/2008 11:24'!
greenColor

	^ Color green! !

!SVNCreateProjectDialog methodsFor: 'initialize-release' stamp: 'rkrk 3/3/2008 11:19'!
initialize

	super initialize.
	self
		theName: self defaultName;
		url: self defaultURL;
		workingCopyPath: self defaultWCPath.! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'rkrk 3/3/2008 11:18'!
okButtonLabel

	^'Create project'! !

!SVNCreateProjectDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 08:47'!
redColor
	^Color red! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 20:45'!
setTheName: aString

	self theName: aString asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rt 3/3/2008 18:12'!
setUrl: aString
	
	self url: aString asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rt 3/3/2008 12:41'!
setWorkingCopyPath: aText

	self workingCopyPath: (self getFullPathFor: aText asString).
	^ true! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:17'!
theName

	^ theName! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rt 3/3/2008 12:38'!
theName: aString

	theName := aString.! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:16'!
url

	^ url! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:25'!
url: aString
	
	url := aString.! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 10:53'!
widget

	^ widget! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 10:54'!
widget: aMorph

	widget := aMorph! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:15'!
workingCopyPath

	^ workingCopyPath! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 11:26'!
workingCopyPath: aString

	workingCopyPath := aString.! !

Model subclass: #SVNDialog
	instanceVariableNames: 'builder widget selector title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

SVNDialog subclass: #SVNAddClassDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNAddClassDialog class methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 12:08'!
open
	| instance |			
	instance := self new.
	ToolBuilder default open: instance.
	^instance! !

!SVNAddClassDialog methodsFor: 'functionality' stamp: 'rkrk 3/4/2008 04:11'!
addClassName
	| class |
	class := Smalltalk classNamed: text asString.
	class ifNil:[^ nil].
	self changed: #addClass with: class.
	self close.! !

!SVNAddClassDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 11:55'!
canAccept: aString
	(SystemDictionary new classNamed: aString asString )
		ifNil:[^false]
		ifNotNil: [^true].! !

!SVNAddClassDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 12:43'!
dialogSelector
	^#addClass! !

!SVNAddClassDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 11:52'!
dialogTitle
	^'Add class to SVNProject'! !

!SVNDialog class methodsFor: 'open' stamp: 'rkrk 3/3/2008 10:49'!
openWith: aString

	| instance |			
	instance := self new
			text: aString;
			yourself.
	ToolBuilder default open: instance.
	^instance! !

!SVNDialog methodsFor: 'ui' stamp: 'rkrk 3/3/2008 11:04'!
buildWith: aBuilder

	| windowSpec okButton cancelButton stringField |
	builder := aBuilder.
	windowSpec := (self builder pluggableWindowSpec new)
				extent: 300 @ 60;
				model: self;
				label: self dialogTitle;
				children: OrderedCollection new.
							
	stringField := (self builder pluggableInputFieldSpec new)
				model: self;
				getText: #text;
				setText: #text:;
				frame: (0 @ 0 corner: 1 @ 0.5).
				
	okButton := (self builder pluggableButtonSpec new)
				model: self;
				label: #okButtonLabel;
				action: #editedText;
				color: #greenColor;
				state: #canAccept;
				frame: (0 @ 0.5 corner: 0.5 @ 1).
				
	cancelButton := (self builder pluggableButtonSpec new)
				model: self;
				label: #cancelButtonLabel;
				action: #close;
				color: #redColor;
				frame: (0.5 @ 0.5 corner: 1 @ 1).
				
	windowSpec children add: stringField.
	windowSpec children add: okButton.
	windowSpec children add: cancelButton.
	windowSpec frame: (0 @ 0 corner: 1 @ 1).
	self widget: (self builder build: windowSpec).
	^ self widget.! !

!SVNDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 10:48'!
builder

	^ builder! !

!SVNDialog methodsFor: 'functionality' stamp: 'rkrk 3/3/2008 10:46'!
canAccept

	^ self canAccept: self text! !

!SVNDialog methodsFor: 'functionality' stamp: 'rkrk 3/3/2008 10:47'!
canAccept: aText

	aText ifNil: [^ false]
		ifNotNil: [^ true]! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
cancelButtonLabel
	^'Cancel'! !

!SVNDialog methodsFor: 'ui' stamp: 'rkrk 3/3/2008 10:41'!
close
	self builder close: widget! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:55'!
dialogSelector
	^self subclassResponsibility ! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:55'!
dialogTitle
	^self subclassResponsibility ! !

!SVNDialog methodsFor: 'functionality' stamp: 'cop 2/28/2008 11:56'!
editedText
	self canAccept 
		ifTrue: 
			[self changed: self dialogSelector with: text.
			self close]! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
greenColor
	^Color green! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 11:25'!
okButtonLabel
	^'Ok'! !

!SVNDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:46'!
redColor
	^Color red! !

!SVNDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 10:50'!
selector: aSelector
	selector := aSelector! !

!SVNDialog methodsFor: 'accessing' stamp: 'cop 2/28/2008 11:55'!
text
	^ text! !

!SVNDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 10:50'!
text: aText
	(self canAccept: aText) ifFalse: [^ false].
	text := aText.
	^ true! !

!SVNDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 10:55'!
widget

	^ widget! !

!SVNDialog methodsFor: 'accessing' stamp: 'rkrk 3/3/2008 10:44'!
widget: aWidget

	widget := aWidget! !

SVNDialog subclass: #SVNSetURLDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNSetURLDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:59'!
dialogSelector
	^#editedURL! !

!SVNSetURLDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:58'!
dialogTitle
	^'Edit SVNProject URL'! !

SVNDialog subclass: #SVNSetWCPathDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNSetWCPathDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:59'!
dialogSelector
	^#editedWCPath! !

!SVNSetWCPathDialog methodsFor: 'ui' stamp: 'cop 2/28/2008 10:58'!
dialogTitle
	^'Edit working copy path'! !

Model subclass: #SVNProjectBrowser
	instanceVariableNames: 'projectNodes selectedNode browserMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Tools'!

!SVNProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'cop 2/26/2008 13:51'!
open
	^self openOn: (SVNProject allInstances asOrderedCollection )! !

!SVNProjectBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/4/2008 03:43'!
openOn: aCollection

	| instance |	
	instance := self new setListOfProjectNodes: aCollection.
	ToolBuilder default open: instance.
	^ instance! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'mu 3/13/2008 15:19'!
buildWith: builder 
	| windowSpec treeSpec createButton listSpec1 listSpec2 listSpec3 |
	windowSpec := (builder pluggableWindowSpec new)
				extent: 600 @ 500;
				model: self;
				label: 'SqueakSVN Project Browser';
				closeAction: #closeWindow;
				children: OrderedCollection new.
				
	treeSpec := (builder pluggableTreeSpec new)
				model: self;
				roots: #projectNodes;
				hasChildren: #nodeHasChildren:;
				getChildren: #getChildrenOfNode:;
				label: #labelOfNode:;
				menu: #menuOn:;
				getSelectedPath: #getPathToSelectedNode;
				setSelected: #setSelectedNode:;
				frame: (0 @ 0 corner: 0.33 @ 0.9).
	
	listSpec1 := (builder pluggableListSpec new)
				model: self;
				frame: (0.33 @ 0 corner: 0.66 @ 0.5).
	
	listSpec2 := (builder pluggableListSpec new)
				model: self;
				frame: (0.33 @  0.5 corner: 0.66 @ 0.9).
				
	listSpec3 := (builder pluggableListSpec new)
				model: self;
				frame: (0.66 @ 0 corner: 1 @ 0.9).
				
	createButton := (builder pluggableButtonSpec new)
				model: self;
				label: #createButtonLabel;
				action: #createProject;
				color: #grayColor;
				frame: (0 @ 0.9 corner: 0.33 @ 1).
				
	windowSpec children add: treeSpec.
	windowSpec children add: createButton.
	windowSpec children add: listSpec1.
	windowSpec children add: listSpec2.
	windowSpec children add: listSpec3.
	self flag: #TODO.
	browserMorph := builder build: windowSpec.
	^ browserMorph! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'rkrk 3/4/2008 03:41'!
closeWindow
	"Free the pointers to prevent pointer cycle"
	self projectNodes: OrderedCollection new.
	selectedNode := nil.
	browserMorph := nil.! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/26/2008 15:59'!
createButtonLabel
	^'Create project'! !

!SVNProjectBrowser methodsFor: 'functionality' stamp: 'rkrk 3/3/2008 20:48'!
createProject
	
	SVNCreateProjectDialog open myDependents: {self}! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'cop 2/26/2008 16:36'!
defaultMenuOn: aMenu
	"aMenu label: 'Manage projects'."
	aMenu add: 'Create Project' action: #createProject.
	^aMenu! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/26/2008 11:39'!
getChildrenOfNode: aNode 
	^ aNode getChildren! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/27/2008 16:56'!
getPathToSelectedNode
	| aCollection aNode |
	aNode := selectedNode.
	aCollection := OrderedCollection new.
	[aNode isNil not ] whileTrue: [aCollection addLast: aNode.
									aNode := aNode parent. ].
	^ aCollection! !

!SVNProjectBrowser methodsFor: 'ui' stamp: 'cop 2/28/2008 10:10'!
grayColor
	^Color gray ! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/26/2008 11:53'!
labelOfNode: aNode 
	^ aNode getLabel! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'cop 2/27/2008 13:30'!
menuOn: aMenu 
	self getPathToSelectedNode isEmpty ifTrue: [^ self defaultMenuOn: aMenu].
	^ self getPathToSelectedNode first getMenuOn: aMenu! !

!SVNProjectBrowser methodsFor: 'node handling' stamp: 'cop 2/26/2008 11:52'!
nodeHasChildren: aNode 
	^ (self getChildrenOfNode: aNode) notEmpty! !

!SVNProjectBrowser methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:41'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:40'!
projectNodes
	^ projectNodes! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:48'!
projectNodes: anObject
	projectNodes := anObject asOrderedCollection! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:45'!
setListOfProjectNodes: aCollection

	aCollection do: [:each | (SVNProjectNode element: each) addDependent: self].
	self projectNodes: aCollection.! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'cop 2/27/2008 13:25'!
setSelectedNode: aNode 
	selectedNode := aNode! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 2/28/2008 12:46'!
update: aSelector
	aSelector == #updateTree ifTrue: [ self updateTree. ^self ].	
	super update: aSelector.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 3/4/2008 03:40'!
update: aSelector with: anObject
	aSelector == #newProject ifTrue: [
								self projectNodes add: ((SVNProjectNode element: anObject) myDependents: (Array with: self)).
								self updateTree.
								^self].
	aSelector == 	#deleteMe ifTrue: [self projectNodes remove: anObject.
									self updateTree. ^self ].	
	super update: aSelector with: anObject.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 3/4/2008 03:47'!
updateTree
	self flag: #TODO.
	browserMorph submorphs do: [:each | each update: #projectNodes].
	browserMorph submorphs do: [:each | each update: #getPathToSelectedNode]! !

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 2/22/2008 11:55'!
basicSvnAddProperty: property WithValue:value To: target
 
	<primitive: 'svnAddPropertyWithValueTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:34'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 3/6/2008 11:04'!
basicSvnCommit: collectionOfPathesToTargets withMessage: aString
 
	<primitive: 'svnCommitWithMessage' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/10/2008 15:59'!
basicSvnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets

	<primitive: 'svnDeleteTargetsFromWorkingCopy' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'cop 3/9/2008 16:47'!
basicSvnGetBlameLinesFrom: target
 
	<primitive: 'svnGetBlameLinesFrom' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 3/12/2008 13:18'!
basicSvnGetCommitLogFrom: target with: revisionNumber  
	<primitive: 'svnGetCommitLogFromwith' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnGetHeadRevision: pathToTarget

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/27/2008 00:06'!
basicSvnGetPropertiesFrom: target
 
	<primitive: 'svnGetPropertiesFrom' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:18'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber
 
	<primitive: 'svnUpdateTargetsToRevisionByNumber' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets
 
	<primitive: 'svnUpdateTargetsToHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNClient methodsFor: 'converting' stamp: 'rt 2/5/2008 11:32'!
normalizePath: aString 

	| modifiedPath returnPath |
	modifiedPath := aString collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^(returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 2/25/2008 11:54'!
svnAdd: aPath 

	^self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'test 3/1/2008 02:36'!
svnAddProperty: property WithValue:value To: target

	| propertyToAdd valueToAdd |
	self flag: #TODO. "Make conversion more clear and consider read also"
	propertyToAdd := property = ''
		ifTrue: ['nil']
		ifFalse: [property].
	valueToAdd := value = ''
		ifTrue: ['nil']
		ifFalse: [value asString].
	^self
		basicSvnAddProperty: propertyToAdd
		WithValue: valueToAdd
		To: (self normalizePath: target).! !

!SVNClient methodsFor: 'accessing' stamp: 'test 3/14/2008 03:55'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self
		basicSvnCheckoutHeadRevisionFrom: (self normalizePath: repositoryURL)
		to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 14:56'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	self basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 18:59'!
svnCommit: aCollection 

	self svnCommit: aCollection withMessage: 'empty commit message'.! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 3/5/2008 15:54'!
svnCommit: aCollection withMessage: aString

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnCommit: commitArray withMessage: aString! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 3/10/2008 16:00'!
svnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets 
	| deleteArray |
	deleteArray := collectionOfPathsToTargets 
				collect: [:each | self normalizePath: each].
	self basicSvnDeleteTargetsFromWorkingCopy: deleteArray! !

!SVNClient methodsFor: 'accessing' stamp: 'cop 3/9/2008 17:04'!
svnGetBlameLinesFrom: target

	^self basicSvnGetBlameLinesFrom: (self normalizePath: target).! !

!SVNClient methodsFor: 'svn primitives' stamp: 'pe 3/12/2008 13:16'!
svnGetCommitLogFrom: target with: revisionNumber 
	^ self basicSvnGetCommitLogFrom: (self normalizePath: target) with: revisionNumber! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 02:34'!
svnGetHeadRevision: aPath

	^ self basicSvnGetHeadRevision: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 15:20'!
svnGetPropertiesFrom: target

	| propertyArray popertyDict correctKey correctValue |
	propertyArray := (self basicSvnGetPropertiesFrom: (self normalizePath: target)).
	popertyDict := Dictionary new.
	propertyArray ifEmpty: [^ popertyDict].
	propertyArray pairsDo: [:key :value |
		correctKey := key = 'nil'	ifTrue: [''] ifFalse: [key].
		correctValue := value = 'nil' ifTrue: [''] ifFalse: [value].
		popertyDict at: correctKey put: correctValue].
	^ popertyDict.! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:25'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargets: updateArray toRevisionByNumber: revisionNumber! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:21'!
svnUpdateTargetsToHeadRevision: aCollection 

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargetsToHeadRevision: updateArray! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/16/2008 07:39'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2]].! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:08'!
basicSvnAdd: aPath 

	self executeViaOSProcessSynchronously: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'pe 2/26/2008 13:29'!
basicSvnAddProperty: key WithValue: value To: path

	| command |
	command := self buildCmdPropset: key value: value for: path.
	self executeViaOSProcessSynchronously: command.! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:35'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:37'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self executeViaOSProcessSynchronously: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'pe 3/6/2008 11:16'!
basicSvnCommit: collectionOfTargets withMessage: aString

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn commit' , targets , ' -m "',aString,'"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:49'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up -r', revisionNumber asString , targets! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:44'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up' , targets! !

!SVNCommandLineClient methodsFor: 'build commands' stamp: 'pe 2/26/2008 13:27'!
buildCmdPropset: key value: value for: path 
	
	^ 'svn propset ' , key , ' ' , value , ' ' , path.! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rkrk 3/16/2008 07:38'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2].].! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'rt 2/7/2008 10:56'!
normalizePath: aPath

	^'"' , (super normalizePath: aPath) , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

Object subclass: #SVNDirectoryEntry
	instanceVariableNames: 'theName basePath properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

SVNDirectoryEntry subclass: #SVNDirectory
	instanceVariableNames: 'subdirectories files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNDirectory class methodsFor: 'instance creation' stamp: 'rkrk 2/25/2008 00:21'!
on: pathString
	
	FileDirectory
		splitName: pathString
		to: [:dirPath :localName |
			^ self named: localName basePath: dirPath].! !

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self files = other files]) and:
			[self subdirectories = other subdirectories]! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 3/6/2008 14:58'!
addFile: svnFile

	"assure that there is no file with the same name"
	self files removeAllSuchThat: [:file | file theName = svnFile theName].
	svnFile basePath: self path.
	self files add: svnFile.! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 3/6/2008 14:57'!
addSubdirectory: svnDirectory

	"assure that there is no file with the same name"
	self subdirectories removeAllSuchThat: [:dir | dir theName = svnDirectory theName].
	svnDirectory basePath: self path.
	self subdirectories add: svnDirectory.! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 3/3/2008 21:13'!
assureExistenceInParent
	"create a directory with the name 'theName' in 'self basePath' if it does not exists and add the directory to the working copy"

	| directory client |
	directory := FileDirectory on: self path.
	directory exists ifTrue: [^ self].
	
	(directory directoryExists: self basePath) ifFalse: [^ self].
	
	directory createDirectory: self path.
	client := SVNCApiClient new.
	client svnAdd: self path.! !

!SVNDirectory methodsFor: 'svn functions' stamp: 'rkrk 3/14/2008 02:57'!
commitWithMessage: aString

	| svnClient |
	self flag: #TODO. "Implement the primitives?"
	svnClient := SVNCApiClient new.
	"svn add the elements"
	"self svnAdd."
	svnClient
		svnCommit: {self path}
		withMessage: aString.! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'test 3/5/2008 00:16'!
createFileNamed: filename 

	^ self
		createFileNamed: filename
		withContent: String new.! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 3/5/2008 01:38'!
createFileNamed: filename withContent: content

	| newFile |
	newFile := SVNFile
		named: filename
		basePath: self path
		content: content.
	self addFile: newFile.
	^ newFile! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rt 3/14/2008 15:20'!
createSubDirectoryNamed: aString 
	
	| newDirectory |
	self flag: #TODO. "Test schreiben!!!!!!!!"
	(self subdirectories anySatisfy: [:each | each theName = aString])
		ifTrue: [^ (self subdirectories detect: [:each | each theName = aString])].
	newDirectory := self class
		named: aString
		basePath: self path.
	self addSubdirectory: newDirectory.
	^ newDirectory.! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 3/4/2008 06:13'!
delete

	| fileDir dotSvnDir |
	fileDir := FileDirectory on: self basePath.
	
	self flag: #TODO.
	fileDir deleteFileNamed: '.DS_STORE'.
	dotSvnDir := SVNDirectory named: '.svn' basePath: self path.
	(FileDirectory on: dotSvnDir path) exists ifTrue:
		[dotSvnDir read.
		dotSvnDir recursivelyDo: [:svnDirectoryEntry |
			svnDirectoryEntry delete]].
	
	fileDir := FileDirectory on: self basePath.
	(fileDir directoryExists: self theName asString) ifFalse: [^ self].
	fileDir deleteDirectory: self theName.! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:51'!
directoryExists: directoryName 

	^ self subdirectories anySatisfy: [:each |
		each theName = directoryName]! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:35'!
fileExists: fileName

	^ self files anySatisfy: [:each | fileName = each theName].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files
	^ files! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files: anObject
	files := anObject! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getFileNamed: fileName 
	
	^ self files
		detect: [:each | each theName = fileName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getSubDirectoryNamed: directoryName 
	
	^ self subdirectories
		detect: [:each | each theName = directoryName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'initialization' stamp: 'rt 3/13/2008 12:02'!
initialize

	super initialize.
	self
		files: Set new;
		subdirectories: Set new;
		theName: String new! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/1/2008 00:47'!
pathsOfAllElements

	^ ((self files union: self subdirectories) collect: [:each | each path]) asOrderedCollection.! !

!SVNDirectory methodsFor: 'printing' stamp: 'rkrk 2/23/2008 22:05'!
printOn: aStream

	| printBlock |
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self theName;
		nextPutAll: ' - Subdirectories:'.
	printBlock := [:each |
		aStream
			nextPut: Character space;
			nextPutAll: each theName].
	self subdirectories do: printBlock.
	aStream nextPutAll: ' - Files:'.
	self files do: printBlock.
	aStream nextPut: $).! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileDirectory on: self path) exists
		ifFalse: [self error: 'There exists no directory with this name.'].
	super read.
	self readDirectoryEntries.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 3/5/2008 15:27'!
readDirectoriesInDir: dir

	| newSvnDirectory |
	dir directoryNames
		select: [:each | each ~= '.svn']
		thenDo: [:each |
			"each = 'SVNTestClassCreatedInAcceptanceTest' ifTrue: [self halt]."
			newSvnDirectory := SVNDirectory
				named: each
				basePath: self path.
				"self halt."
			newSvnDirectory read.
			self addSubdirectory: newSvnDirectory].! !

!SVNDirectory methodsFor: 'reading' stamp: 'test 3/1/2008 02:49'!
readDirectoryEntries

	| dir |
	dir := FileDirectory on: self path.
	self
		readFilesInDir: dir;
		readDirectoriesInDir: dir.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rt 3/5/2008 13:25'!
readFilesInDir: directory

	| newSvnFile |
	directory fileNames do: [:each |
			newSvnFile := SVNFile
				named: each
				basePath: self path.
			newSvnFile read.
			self files add: newSvnFile].! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 3/4/2008 05:19'!
recursivelyDo: aBlock

	self flag: #TODO. "Testen".
	(self files union: self subdirectories) do: [:ea |
		ea recursivelyDo: aBlock].
	aBlock value: self.! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'test 2/25/2008 15:39'!
recursivelyGatherPathsOfAllElements

	| subElementsPaths |
	subElementsPaths := self subdirectories
			gather: [:each | each recursivelyGatherPathsOfAllElements].
	^ self pathsOfAllElements
		addAll: subElementsPaths;
		yourself.! !

!SVNDirectory methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 15:12'!
remove

	((FileDirectory new) directoryExists: self path) ifFalse: [^ self].
	
	super remove.! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rt 3/14/2008 15:10'!
removeSubDirectoryNamed: aString 
	
	| |
	self flag: #TODO. "Test schreiben!!!!!!!!"
	(self subdirectories anySatisfy: [:each | each theName = aString])
		ifTrue: [^ (self subdirectories detect: [:each | each theName = aString]) remove].

	^ nil.! !

!SVNDirectory methodsFor: 'storing' stamp: 'rt 3/14/2008 15:14'!
store
	(FileDirectory on: self path) assureExistence.
	super store.
	(self files union: self subdirectories) do: [:each |
		each store].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories
	^ subdirectories! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories: anObject
	subdirectories := anObject! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 3/12/2008 14:44'!
asciiValueSeparator

	^ $%! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 3/12/2008 14:55'!
illegalCharacters

	^ #($/ $\ $? $* $: $| $" $< $>)! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 3/5/2008 19:57'!
named: aString basePath: pathName

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ self new
		encodeName: aString;
		basePath: pathName
		yourself.! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:42'!
= other

	self species = other species ifFalse: [^ false].
	^ (self theName = other theName and:
		[self basePath = other basePath]) and:
			[self properties = other properties].! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 2/27/2008 02:25'!
addEntry

	| client |
	client := SVNCApiClient new.
	client svnAdd: self path! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:54'!
asciiValueSeparator

	^ self class asciiValueSeparator.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath
	^ basePath! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath: anObject 
	basePath := anObject! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 18:04'!
checkoutFrom: url

	| svnClient |
	svnClient := SVNCApiClient new.
	svnClient
		svnCheckoutHeadRevisionFrom: url asString
		to: self path.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 18:03'!
commit

	self commitWithMessage: String new.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 18:03'!
commitWithMessage: aString

	| svnClient |
	self flag: #TODO. "Implement the primitives?"
	svnClient := SVNCApiClient new.
	"svn add the elements"
	self svnAdd.
	svnClient
		svnCommit: {self path}
		withMessage: aString.! !

!SVNDirectoryEntry methodsFor: 'as yet unclassified' stamp: 'rkrk 3/4/2008 05:20'!
delete! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:58'!
encodeName: aString 

	"Parse the string and construct a filename from it."
	| parts char |
	self flag: #TODO.
	aString first = self asciiValueSeparator ifTrue: [^ aString].
	
	parts := aString subStrings: self asciiValueSeparator asString.
	self theName: (parts
		inject: String new
		into: [:result :each | each isAllDigits
			ifFalse: [result , each]
			ifTrue: [char := Character value: each asNumber.
				result , char asString]]).! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:58'!
encodedName: aString 

	"Parse the string and construct a filename from it."
	| parts char |
	self flag: #TODO.
	aString first = self asciiValueSeparator ifTrue: [^ aString].
	
	parts := aString subStrings: self asciiValueSeparator asString.
	^ parts
		inject: String new
		into: [:result :each | each isAllDigits
			ifFalse: [result , each]
			ifTrue: [char := Character value: each asNumber.
				result , char asString]].! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:55'!
fileNameRepresantationForIllegalCharacter: character

	| sep |
	sep := self asciiValueSeparator asString.
	^  sep , character asciiValue asString , sep.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 19:56'!
filename

	"print it: [self new theName: 'ab:ab'; filename]"
	^ self class illegalCharacters 
		inject: self theName copy
		into: [:convertedName :illegalCharacter |
			convertedName
				copyReplaceAll: illegalCharacter asString
				with: (self fileNameRepresantationForIllegalCharacter: illegalCharacter)].! !

!SVNDirectoryEntry methodsFor: 'testing' stamp: 'rkrk 2/21/2008 21:42'!
hash

	^ self theName hash! !

!SVNDirectoryEntry methodsFor: 'initialization' stamp: 'rt 3/14/2008 15:19'!
initialize

	super initialize.
	self properties: Dictionary new.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 18:03'!
path
	^ self basePath , FileDirectory slash , self filename.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties
	^ properties! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties: anObject
	properties := anObject! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	self	readProperties.! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 3/1/2008 03:04'!
readProperties

	| client |
	client := SVNCApiClient new.
	self properties: (client svnGetPropertiesFrom: self path).! !

!SVNDirectoryEntry methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 15:09'!
remove

	self svnRemoveEntry! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'pe 2/26/2008 11:52'!
store
	self addEntry.
	self storeProperties! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'test 3/1/2008 04:14'!
storeProperties

	| client |
	client := SVNCApiClient new.
	self properties keysAndValuesDo: [:key :value |
		client svnAddProperty: key WithValue: value To: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 15:14'!
svnAdd

	| svnClient |
	svnClient := SVNCApiClient new.
	"svn add the elements"
	svnClient svnAdd: self path.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rt 3/13/2008 17:30'!
svnRemoveEntry

	| client |
	client := SVNCApiClient new.
	client svnDeleteTargetsFromWorkingCopy: {self path}.
	self flag: #TODO. "svn status ??? If entry isn't under version control call: entry delete ?'"! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName

	^ theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 18:54'!
theName: aString 

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	theName := aString asString.! !

SVNDirectoryEntry subclass: #SVNFile
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'test 3/5/2008 15:29'!
named: aString basePath: pathName content: content

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ (self named: aString basePath: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self content = other content])! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'removing' stamp: 'rkrk 3/4/2008 05:13'!
delete

	(FileDirectory on: self basePath) deleteFileNamed: self theName.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 3/5/2008 01:47'!
hash

	"^ (super hash bitXor: self content hash) bitXor: self properties hash."
	self flag: #TODO.
	^ super hash! !

!SVNFile methodsFor: 'initialize-release' stamp: 'rkrk 3/13/2008 11:46'!
initialize

	super initialize.
	content := String new.! !

!SVNFile methodsFor: 'printing' stamp: 'rkrk 2/23/2008 21:59'!
printOn: aStream

	super printOn: aStream.	
	aStream
		nextPut: $(;
		nextPutAll: self theName;
		nextPut: $).! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileStream isAFileNamed: self path)
		ifFalse: [self error: 'There exists no file with this name!!'].
	super read.
	self	readContent.! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/27/2008 02:26'!
readContent

	FileStream 
		readOnlyFileNamed: self path
		do: [:stream | content := stream contents.]! !

!SVNFile methodsFor: 'as yet unclassified' stamp: 'rkrk 3/4/2008 05:20'!
recursivelyDo: aBlock

	self flag: #TODO. "Testen".
	aBlock value: self.! !

!SVNFile methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 16:20'!
remove

	| dir |
	dir := (FileDirectory on: self basePath).
	dir exists ifFalse: [^ self].
	(dir fileExists: self filename) ifFalse: [^ self].

	super remove! !

!SVNFile methodsFor: 'storing' stamp: 'rt 3/14/2008 15:15'!
store
	"self assert: (self theName includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	FileStream 
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: content].
	super store.! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 3/14/2008 02:25'!
< other

	^ super < other! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/23/2008 11:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'timestamp'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

Object subclass: #SVNDummy99
	instanceVariableNames: 'a'
	classVariableNames: 'A'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy99 class
	instanceVariableNames: 'b'!

SVNDummy99 class
	instanceVariableNames: 'b'!

Object subclass: #SVNElement
	instanceVariableNames: 'theName parent svnDirectoryEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'theClass superclassName classVariables instanceVariables classInstanceVariables comment category subclasses versionedMethods poolDictionaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/23/2008 19:44'!
forExistingClass: aClass

	^ (self new)
		forExistingClass: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/23/2008 21:47'!
forSerializedClassIn: aSVNDirectory 
	
	^ self new
		forSerializedClassIn: aSVNDirectory;
		yourself.! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rt 3/9/2008 17:39'!
name: className superclassName: superClassName instanceVariables: instVars classVariables: classVars classInstanceVariables: classInstVars poolDictionaries: poolDicts comment: comment category: classCategory

	^ self new
		theName: className;
		superclassName: superClassName;
		instanceVariables: instVars;
		classVariables: classVars;
		classInstanceVariables: classInstVars;
		poolDictionaries: poolDicts;
		comment:  comment;
		category: classCategory;
		yourself.! !

!SVNClass methodsFor: 'comparing' stamp: 'rt 3/9/2008 18:06'!
= other

	super = other ifFalse: [^ false].
	(self superclassName = other superclassName and:
		[self instanceVariables = other instanceVariables] and:
		[self classVariables = other classVariables] and:
		[self classInstanceVariables = other classInstanceVariables] and:
		[self comment = other comment]) ifFalse: [^ false].
	^  self category = other category and:
		[self poolDictionaries = other poolDictionaries] and:
		[self versionedMethods = other versionedMethods]! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category
	^ category! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category: anObject
	category := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables
	^ classInstanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables: anObject
	classInstanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classInstanceVariablesString

	^ self stringFromCollection: self classInstanceVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables
	^ classVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables: anObject
	classVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classVariablesString

	^ self stringFromCollection: self classVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment
	^ comment! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment: anObject
	comment := anObject! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/21/2008 16:40'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 14:15'!
directory

	^ self svnDirectoryEntry! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 14:15'!
directory: aSVNDirectory

	self svnDirectoryEntry: aSVNDirectory! !

!SVNClass methodsFor: 'notification' stamp: 'rt 3/14/2008 16:48'!
event: anEvent

	| class eventItemClass result |
	self flag: #TODO.
	self theName ifNil: [^self].
	eventItemClass := anEvent itemClass.
	class := Smalltalk classNamed: self theName.

	(eventItemClass = class or: [eventItemClass = class class]) ifFalse: [^self].

	result := self handleEvent: anEvent.
	result = anEvent ifTrue: [self forExistingClass: class.]
! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/14/2008 18:58'!
extractCategoryFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForCategoryProperty) content asSymbol! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractClassVarsFrom: aSVNDirectory
	
	^ ((aSVNDirectory getFileNamed: self nameForClassVariablesProperty) content substrings collect: [:each | each asSymbol]) asSet! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:00'!
extractInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractMetaInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForClassInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:37'!
extractPoolDictionariesFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForPoolDictionariesProperty) content substrings asOrderedCollection! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:36'!
extractSuperclassFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForSuperclassProperty) content! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rt 3/14/2008 14:42'!
forExistingClass: aClass

	self
		theName: aClass name asString;
		superclassName: aClass superclass name asString;
		instanceVariables: aClass instVarNames;
		classVariables: aClass classVarNames;
		classInstanceVariables: aClass class instVarNames;
		poolDictionaries: aClass poolDictionaryNames;
		comment: aClass comment;
		category: aClass category.
	
	"self halt."
	self versionedMethods: ((aClass methodDict collect: [:each |
		SVNMethod forExistingMethod: each])
			union: (aClass class methodDict collect: [:each |
				SVNMethod forExistingMethod: each])).
	
	self versionedMethods do: [:each | self setPlaceOnDiskFor: each]
	
	"self theClass: aClass."! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/23/2008 21:52'!
forSerializedClassIn: svnDirectory 
	
	self restoreFrom: svnDirectory.! !

!SVNClass methodsFor: 'notification' stamp: 'rt 3/14/2008 16:44'!
handleEvent: anEvent

	| eventItemClass removedItem |

	anEvent isRemoved ifFalse: [^ anEvent].
	
	((anEvent itemKind = #class) and:
		[anEvent item name asString = self theName]) ifTrue: [^ self remove].
	
	anEvent itemKind = #method ifFalse: [^ anEvent].
	eventItemClass := anEvent itemClass asString.

	(removedItem := (self versionedMethods detect: [:each |
		(each methodSelector asSymbol = anEvent itemSelector)
			and: [each nameOfClass = eventItemClass]]
				ifNone: [nil])).
	removedItem ifNotNil: [self versionedMethods remove: (removedItem remove)]! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 13:29'!
hash

	^ self theName hash! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rt 3/14/2008 14:49'!
initialize

	super initialize.
	self
		versionedMethods: {};
		subclasses: {};
		notifyAboutSystemModifications: true. self flag: #TODO "Not good"! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables
	^ instanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables: anObject
	instanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 23:59'!
instanceVariablesString

	^ self stringFromCollection: self instanceVariables.! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rt 3/9/2008 18:36'!
load
	
	| superclass |
	self flag: #TODO.
	self notifyAboutSystemModifications: false.
	(Smalltalk classNamed: self theName asSymbol) ifNotNilDo: [:alreadyExistingClass |
			alreadyExistingClass removeFromSystem].
		
	self poolDictionaries do: [:each | Smalltalk at: each asSymbol ifAbsentPut: Dictionary new].
		
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	self theClass: (superclass
				subclass: self theName asSymbol
				instanceVariableNames: self instanceVariablesString
				classVariableNames: self classVariablesString
				poolDictionaries: self poolDictionariesString
				category: self category).
	self theClass classSide instanceVariableNames: self classInstanceVariablesString.
	
	self versionedMethods do: [:each | each load].	
	self subclasses do: [:each | each load].
	
	self notifyAboutSystemModifications: true.! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:03'!
nameForCategoryProperty
	^'category'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:16'!
nameForClassInstanceVariablesProperty
	^ 'classInstanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForClassVariablesProperty
	^ 'classVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 12:03'!
nameForCommentFile

	^ 'comment'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForInstanceVariablesProperty
	^ 'instanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 3/9/2008 16:45'!
nameForPoolDictionariesProperty
	^'poolDictionaries'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:05'!
nameForSuperclassProperty
	^'superclass'! !

!SVNClass methodsFor: 'notification' stamp: 'rkrk 3/4/2008 03:19'!
notifyAboutSystemModifications: aBoolean

	| notifier |
	self flag: #TODO. "What about #category, #protocol?"
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				using: #event:.
			notifier
				notify: self
				ofSystemChangesOfItem: #method
				using: #event:].! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries

	^poolDictionaries! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries: anObject

	poolDictionaries := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rt 3/9/2008 16:46'!
poolDictionariesString

	^ self stringFromCollection: self poolDictionaries.! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/23/2008 23:52'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'removing' stamp: 'rt 3/14/2008 16:52'!
removeSVNMethod: svnMethod

	self directory ifNotNil: [self directory files remove: svnMethod file].
	self versionedMethods remove: svnMethod.! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 3/12/2008 12:31'!
restoreClassDetailsFrom: aSVNDirectory 

	self
		superclassName: (self extractSuperclassFrom: aSVNDirectory) ;
		instanceVariables: (self extractInstVarsFrom: aSVNDirectory) ;
		classVariables: (self extractClassVarsFrom: aSVNDirectory) ;
		classInstanceVariables: (self extractMetaInstVarsFrom: aSVNDirectory);
		poolDictionaries: (self extractPoolDictionariesFrom: aSVNDirectory);
		category: (self extractCategoryFrom: aSVNDirectory)! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 3/14/2008 18:59'!
restoreFrom: aSVNDirectory 

	self
		theName: aSVNDirectory theName;
		directory: aSVNDirectory;
		restoreClassDetailsFrom: aSVNDirectory;
		comment: (aSVNDirectory getFileNamed: self nameForCommentFile) content.

	self versionedMethods: {} asSet.
	aSVNDirectory subdirectories do: [:each | self restoreMethodsFrom: each].! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 3/9/2008 00:49'!
restoreMethodsFrom: aSVNDirectory 

	self unionVersionedMethodsWith: (aSVNDirectory files 
				collect: [:each | SVNMethod restoreFrom: each])! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 18:05'!
saveYourselfIn: aSVNDirectory

	| dir |
	dir := aSVNDirectory createSubDirectoryNamed: self theName.
	dir createSubDirectoryNamed: 'instance'.
	dir createSubDirectoryNamed: 'class'.

	self directory: dir.
	self versionedMethods do: [:method | self setPlaceOnDiskFor: method]! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 14:44'!
setPlaceOnDiskFor: aSVNMethod

	self directory ifNil: [^ self].
	
	aSVNMethod isPartOfMetaclass
		ifTrue: [aSVNMethod saveYourselfIn: (self directory getSubDirectoryNamed: 'class')]
		ifFalse: [aSVNMethod saveYourselfIn: (self directory getSubDirectoryNamed: 'instance')]! !

!SVNClass methodsFor: 'storing' stamp: 'rt 3/12/2008 11:14'!
storeClassDetailsIn: svnDirectory 

	svnDirectory
		createFileNamed: self nameForSuperclassProperty
		withContent: self superclassName asString.
	svnDirectory
		createFileNamed: self nameForCategoryProperty
		withContent: self category asString.
	svnDirectory
		createFileNamed: self nameForPoolDictionariesProperty
		withContent: self poolDictionariesString.
	svnDirectory
		createFileNamed: self nameForInstanceVariablesProperty
		withContent: self instanceVariablesString.
	svnDirectory
		createFileNamed: self nameForClassVariablesProperty
		withContent: self classVariablesString.
	svnDirectory
		createFileNamed: self nameForClassInstanceVariablesProperty
		withContent: self classInstanceVariablesString.! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/25/2008 01:45'!
storeCommentIn: svnDirectory 

	svnDirectory
		createFileNamed: self nameForCommentFile
		withContent: self comment.! !

!SVNClass methodsFor: 'storing' stamp: 'rt 3/14/2008 14:53'!
storeIn: svnDirectory

	| classDirectory |
	"self assert: self theClass notNil."	
	self flag: #TODO. "classDirectory is self directory"
	classDirectory := svnDirectory createSubDirectoryNamed: self theName.
	self
		storeVersionedMethodsIn: classDirectory ;
		storeCommentIn: classDirectory ;
		storeClassDetailsIn: classDirectory.	"Change the name"
	"TODO: pass projectDirectory to all my elements"
	"classDirectory store."! !

!SVNClass methodsFor: 'storing' stamp: 'rt 3/14/2008 14:57'!
storeVersionedMethodsIn: svnDirectory

	| instanceSideDirectory classSideDirectory |
	self flag: #TODO. "now the versions know their place on the disk"
	instanceSideDirectory := svnDirectory createSubDirectoryNamed: 'instance'.
	instanceSideDirectory files: Set new.
	
	classSideDirectory := svnDirectory createSubDirectoryNamed: 'class'.
	classSideDirectory files: Set new.
	
	self versionedMethods do: [:each |
		(each isPartOfMetaclass)
			ifTrue: [each storeIn: classSideDirectory]
			ifFalse: [each storeIn: instanceSideDirectory]]! !

!SVNClass methodsFor: 'convenience' stamp: 'rkrk 2/23/2008 23:59'!
stringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:16'!
subclasses

	^subclasses! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:14'!
subclasses: anObject

	subclasses := anObject asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName
	^ superclassName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName: anObject
	superclassName := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'test 3/5/2008 02:06'!
theClass
	^ Smalltalk classNamed: self theName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass: aClass 
	theClass := aClass! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 00:49'!
unionVersionedMethodsWith: anObject 

	^ self versionedMethods: (self versionedMethods union: anObject)! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 01:13'!
versionedMethods
	
	^ versionedMethods! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/8/2008 22:08'!
versionedMethods: anObject

	versionedMethods := anObject asSet! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:40'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName
! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
commit
	^self subclassResponsibility! !

!SVNElement methodsFor: 'svn commands' stamp: 'pe 3/5/2008 11:43'!
commitWithMessage: aString
	^self subclassResponsibility! !

!SVNElement methodsFor: 'read' stamp: 'mu 2/7/2008 13:54'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
delete
	^self subclassResponsibility! !

!SVNElement methodsFor: 'accessing' stamp: 'cop 2/28/2008 12:26'!
parent
	^parent! !

!SVNElement methodsFor: 'accessing' stamp: 'cop 2/28/2008 12:26'!
parent: aSVNElement
	parent := aSVNElement! !

!SVNElement methodsFor: 'write' stamp: 'cop 2/12/2008 11:50'!
readElementFrom: aPath for: anObject 
	self subclassResponsibility! !

!SVNElement methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 15:22'!
remove
	(self svnDirectoryEntry) ifNil: [^self].
	self svnDirectoryEntry remove! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
revert
	^self subclassResponsibility! !

!SVNElement methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 14:11'!
saveYourselfIn: aSVNDirectory
	self subclassResponsibility! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry

	^ svnDirectoryEntry! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry: aSVNDirectoryEntry

	svnDirectoryEntry := aSVNDirectoryEntry! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:31'!
theName
	^ theName! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 20:43'!
theName: anObject
	theName := anObject asString! !

!SVNElement methodsFor: 'svn commands' stamp: 'cop 2/27/2008 16:30'!
update
	^self subclassResponsibility! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'nameOfClass category source timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/24/2008 01:29'!
forExistingMethod: aCompiledMethod 
	
	^ self new
		forExistingMethod: aCompiledMethod;
		yourself! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rt 3/5/2008 14:11'!
restoreFrom: aSVNFile 

	^ self new
		restoreFrom: aSVNFile;
		yourself.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 01:39'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodSelector = otherMethod methodSelector and: 
		[self category = otherMethod category] and:
			[self source = otherMethod source] and:
				[self nameOfClass = otherMethod nameOfClass] and:
					[self timeStamp = otherMethod timeStamp]! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category
	^ category! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category: anObject
	category := anObject! !

!SVNMethod methodsFor: 'serializing' stamp: 'rkrk 2/24/2008 01:50'!
contentsForFile
	
	"Mapping method to contents of a file"
	self flag: #TODO.
	
	"For now: save the name of the category in the first line. The source code below."
	^ self nameOfClass , String cr , self category , String cr , self timeStamp , String cr , self source! !

!SVNMethod methodsFor: 'as yet unclassified' stamp: 'rt 3/4/2008 12:23'!
delete
	"self halt."! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:00'!
extractCategoryFrom: svnFile

	^ svnFile properties at: self nameForCategoryProperty! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
extractClassFrom: svnFile

	^ svnFile properties at: self nameForClassProperty! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 01:58'!
extractSourceCodeFrom: svnFile

	^ svnFile content! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
extractTimeStampFrom: svnFile

	^ svnFile properties at: self nameForTimeStampProperty! !

!SVNMethod methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 14:18'!
file

	^ self svnDirectoryEntry! !

!SVNMethod methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 14:18'!
file: aSVNFile

	self svnDirectoryEntry: aSVNFile! !

!SVNMethod methodsFor: 'initialize' stamp: 'rkrk 2/24/2008 01:53'!
forExistingMethod: aCompiledMethod

	| methodReference |
	methodReference := aCompiledMethod methodReference.
	self
		methodSelector: methodReference methodSymbol;
		nameOfClass: methodReference actualClass name;
		category: methodReference category;
		source: methodReference source;
		timeStamp: methodReference timeStamp.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 12:36'!
hash

	^ self methodSelector hash! !

!SVNMethod methodsFor: 'accessing' stamp: 'rt 3/10/2008 13:00'!
isPartOfMetaclass

	^self nameOfClass endsWith: ' class'.! !

!SVNMethod methodsFor: 'modifying the system' stamp: 'rt 3/10/2008 13:01'!
load
	
	| class relatedSystemEntry |

	"find the correct class"
	relatedSystemEntry := Smalltalk at: self nameOfClass substrings first asSymbol.
	self isPartOfMetaclass
		ifTrue: [class := relatedSystemEntry class]
		ifFalse: [class := relatedSystemEntry].
		
	class
		compile: self source
		classified: self category
		withStamp: self timeStamp
		notifying: nil.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector

	^ self theName! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector: aString

	self theName: aString! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:00'!
nameForCategoryProperty
	^ 'category'! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
nameForClassProperty
	^ 'class'! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/24/2008 02:01'!
nameForTimeStampProperty
	^ 'timestamp'! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass
	^ nameOfClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass: anObject
	nameOfClass := anObject! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/24/2008 02:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self nameOfClass;
		nextPutAll: '>>';
		nextPutAll: self methodSelector;
		nextPut: $).! !

!SVNMethod methodsFor: 'restoring' stamp: 'rt 3/14/2008 14:23'!
restoreFrom: aSVNFile 

	self
		file: aSVNFile;
		methodSelector: aSVNFile theName asString;
		category: (self extractCategoryFrom: aSVNFile);
		source: (self extractSourceCodeFrom: aSVNFile);
		nameOfClass: (self extractClassFrom: aSVNFile);
		timeStamp: (self extractTimeStampFrom: aSVNFile).! !

!SVNMethod methodsFor: 'as yet unclassified' stamp: 'rt 3/14/2008 17:31'!
saveYourselfIn: aSVNDirectory

	| file |
	file := aSVNDirectory createFileNamed: self theName.
	
	self file: file! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source
	^ source! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source: anObject
	source := anObject! !

!SVNMethod methodsFor: 'storing' stamp: 'rt 3/14/2008 15:02'!
storeIn: aSVNDirectory 
	
	self flag: #TODO. "the mehtods know their files"
	self file: (aSVNDirectory
		createFileNamed: self theName
		withContent: self source).
	self file properties
		at: self nameForClassProperty
		put: self nameOfClass.
	self file properties
		at: self nameForCategoryProperty 
		put: self category.
	self file properties
		at: self nameForTimeStampProperty 
		put: self timeStamp.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp
	^ timeStamp! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp: anObject
	timeStamp := anObject! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods workingCopyDirectory repositoryURL projectDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'pe 2/28/2008 12:18'!
checkoutProject: aName fromURL: url inWorkingCopy: aSVNDirectory 
	
	^ self new
		repositoryURL: url;
		theName: aName;
		workingCopyDirectory: aSVNDirectory;
		checkout;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 3/3/2008 23:58'!
named: aString 
	^self new
		theName: aString;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rt 3/14/2008 14:06'!
restoreFrom: aSVNDirectory 
	
	^ self new
		restoreFrom: aSVNDirectory;
		yourself.! !

!SVNProject methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:50'!
= other

	super = other ifFalse: [^ false].
	^ self versionedClasses = other versionedClasses and:
		[self versionedMethods = other versionedMethods].! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/25/2008 01:35'!
addClass: aClass

	^ self addSVNClass: (SVNClass forExistingClass: aClass)! !

!SVNProject methodsFor: 'adding' stamp: 'rt 3/14/2008 14:26'!
addMethod: aMethod 
	
	self workingCopyDirectory ifNil: [self error: 'No working copy path specified.'].
	^ self versionedMethods add: ((SVNMethod forExistingMethod: aMethod) saveYourselfIn: self projectDirectory)! !

!SVNProject methodsFor: 'adding' stamp: 'rt 3/14/2008 18:05'!
addSVNClass: svnClass

	self workingCopyDirectory ifNil: [self error: 'No working copy path specified.'].
	
	self versionedClasses
		select: [:ea | ea theName asString = svnClass theName asString]
		thenDo: [:alreadyExistingClass | self versionedClasses remove: alreadyExistingClass].
	svnClass saveYourselfIn: self projectDirectory.
	^ self versionedClasses add: svnClass! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rt 3/9/2008 01:06'!
allVersionedMethods
	
	^ self versionedClasses
		inject: self versionedMethods copy
		into: [:allMethods :class | allMethods addAll: class versionedMethods].! !

!SVNProject methodsFor: 'svn functions' stamp: 'rt 3/5/2008 13:28'!
checkout

	self workingCopyDirectory checkoutFrom: self repositoryURL.
	self projectDirectory assureExistenceInParent.
	self projectDirectory read.
	self restoreFrom: self projectDirectory.! !

!SVNProject methodsFor: 'svn functions' stamp: 'rt 3/4/2008 12:55'!
commit

	"self halt."
	self store.
	self projectDirectory commit.
	
	self flag: #TODO. "Wrg, hlich und nicht getestet"
	"self workingCopyDirectory recursivelyDo: [:svnDirectoryEntry |
		svnDirectoryEntry delete]."! !

!SVNProject methodsFor: 'svn functions' stamp: 'pe 3/5/2008 11:44'!
commitWithMessage: aString

	"self halt."
	self store.
	self projectDirectory commitWithMessage:aString.
	
	self flag: #TODO. "Wrg, hlich und nicht getestet"
	"self workingCopyDirectory recursivelyDo: [:svnDirectoryEntry |
		svnDirectoryEntry delete]."! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/13/2008 13:35'!
deleteClass: aClass

	(Smalltalk classNamed: aClass name asString) removeFromSystem.
	"class>>handleEvent will do the rest"
	^aClass! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 3/3/2008 23:59'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'installing' stamp: 'rt 3/8/2008 16:56'!
load
	SVNLoader loadSVNClasses: self versionedClasses copy
		andSVNMethods: self versionedMethods copy! !

!SVNProject methodsFor: 'printing' stamp: 'rkrk 3/3/2008 20:30'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 3/4/2008 00:07'!
projectDirectory

	^ self workingCopyDirectory createSubDirectoryNamed: self theName.! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/13/2008 13:27'!
removeClass: aClass

	| svnClass |
	svnClass := SVNClass forExistingClass: aClass.
	self removeSVNClass: svnClass.
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/14/2008 16:54'!
removeSVNClass: aSVNClass

	| includedClass |
	includedClass := self versionedClasses
							detect: [:each | each theName = aSVNClass theName]
							ifNone: [^ self].
	self projectDirectory subdirectories remove: includedClass directory.
	self versionedClasses remove: (includedClass remove).
	^includedClass! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 3/3/2008 18:32'!
repositoryURL
	
	^ repositoryURL asString! !

!SVNProject methodsFor: 'accessing' stamp: 'test 2/28/2008 11:19'!
repositoryURL: anURL 
	
	repositoryURL := anURL.! !

!SVNProject methodsFor: 'restoring' stamp: 'rt 3/14/2008 20:17'!
restoreFrom: aSVNDirectory 
	
	self flag: #TODO. "Piece of mapping is here"
	self workingCopyDirectory: (SVNDirectory on: aSVNDirectory basePath).
	self workingCopyDirectory subdirectories add: aSVNDirectory.
	self theName: aSVNDirectory theName.
	aSVNDirectory subdirectories do: [:each |
		self addSVNClass: (SVNClass forSerializedClassIn: each)].! !

!SVNProject methodsFor: 'serialization' stamp: 'test 3/14/2008 16:48'!
store

	self storeIn: self workingCopyDirectory.
	self projectDirectory store.! !

!SVNProject methodsFor: 'serialization' stamp: 'rt 3/14/2008 14:35'!
storeIn: svnDirectory 

	self flag: #TODO. "Remove workingCopy directory"
	self workingCopyDirectory: svnDirectory.
	(self versionedClasses union: self versionedMethods) do: [:each |
		each storeIn: self projectDirectory].
	"TODO: pass projectDirectory to all my elements"
	"self projectDirectory store"! !

!SVNProject methodsFor: 'installing' stamp: 'rkrk 2/25/2008 01:48'!
unload
	self flag: #TODO.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 3/8/2008 17:55'!
versionedMethods
	
	^ versionedMethods! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/25/2008 00:26'!
workingCopyDirectory
	^ workingCopyDirectory! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 00:07'!
workingCopyDirectory: anObject

	workingCopyDirectory := anObject.! !

Object subclass: #SVNLoader
	instanceVariableNames: 'requiredClasses classesToLoad unknownRequiredClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:27'!
loadSVNClasses: aSet
"superclasses"
	^self loadSVNClasses: aSet andSVNMethods: (Set new)! !

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:34'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet

	self flag: #TODO. "implement unload..., reload (unload->load)"
	^(self new) loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet! !

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:26'!
loadSVNMethods: aSet
"Classes"
	^self loadSVNClasses: (Set new) andSVNMethods: aSet! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/8/2008 16:44'!
addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet 

	| newDependencies |
	self classesToLoad addAll: (aSVNClassSet collect: [:each | each theName]).
	newDependencies := aSVNClassSet collect: [:each | each superclassName asString].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/10/2008 13:12'!
addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet 

	| newDependencies |
	newDependencies := aSVNMethodSet collect: [:each | each nameOfClass substrings first].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 12:01'!
classesToLoad
	^classesToLoad! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 23:05'!
findOriginInSystemFor: aSVNClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet

	| ownSuperclassName svnSuperClass |
	ownSuperclassName := aSVNClass superclassName.
	ownSuperclassName = aString ifTrue: [^nil].
	(aSet includes: ownSuperclassName) ifFalse: [^ownSuperclassName].
			
	svnSuperClass := (aSVNClassSet select: [:aClass | aClass theName = ownSuperclassName]) someElement.
	
	^self findOriginInSystemFor: svnSuperClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet.! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/7/2008 23:05'!
hasCycle: aSVNClassSet.
	"Answer if there is a cycle in the set of svnClasses.
	Needs that addToRequiredClassesAllDependenciesInSVNClasses: had running."

	aSVNClassSet do: [:eachClass |
			(self
				findOriginInSystemFor: eachClass
				superclassCanNotBe: eachClass theName
				superclassMustBeInSystemOr: aSVNClassSet
				consider: (self requiredClasses intersection: (self classesToLoad))) ifNil: [^true]].
	^false! !

!SVNLoader methodsFor: 'initialization' stamp: 'rt 3/7/2008 12:09'!
initialize
	super initialize.
	requiredClasses := Set new.
	classesToLoad := Set new.
	unknownRequiredClasses := Set new! !

!SVNLoader methodsFor: 'loading' stamp: 'rt 3/10/2008 13:14'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet 

	self addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	self addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet.
	
	self flag: #TODO. "abort, if some required classes are unknown or there are cycles"
	self unknownRequiredClasses ifNotEmpty: [^self].
	(self hasCycle: aSVNClassSet) ifTrue: [^self].
	
	self loadSVNClassesSorted: aSVNClassSet.
	aSVNMethodSet do: [:each | each load]! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/10/2008 13:14'!
loadSVNClassesSorted: aSVNClassSet

	| sortedClasses |
	sortedClasses := self sortSVNClasses: aSVNClassSet consider: (self requiredClasses intersection: self classesToLoad).
	
	sortedClasses do: [:each | each load]! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 00:37'!
requiredClasses
	^requiredClasses! !

!SVNLoader methodsFor: 'sorting' stamp: 'rt 3/7/2008 22:29'!
sortSVNClasses: aSVNClassSet consider: aSet

	| allSubclasses subclasses |
	aSet ifEmpty: [^aSVNClassSet].
	allSubclasses := Set new.
	aSVNClassSet do: [:each |
		(aSet includes: each theName)
			ifTrue: [subclasses := aSVNClassSet select: [:subClass |
												(subClass superclassName = each theName)].
					each subclasses addAll: subclasses.
					allSubclasses addAll: subclasses]].
	
	aSVNClassSet removeAll: allSubclasses.
	^aSVNClassSet! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/8/2008 16:49'!
unknownRequiredClasses
	"all required classes, which are not in classesToLoad and unknown in the system"
	| unknownClasses realyUnknownClasses class |
	unknownClasses := self requiredClasses copy.
	unknownClasses removeAllFoundIn: self classesToLoad.
	realyUnknownClasses := Set new.
	unknownClasses do: [:each | 
		class := Smalltalk classNamed: each.
		(class isNil or: [class isObsolete]) ifTrue: [realyUnknownClasses add: each]].
	^realyUnknownClasses
	! !

Object subclass: #SVNNode
	instanceVariableNames: 'element parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

SVNNode subclass: #SVNClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 16:47'!
getChildren
	^ OrderedCollection 
		with: ((SVNInstanceSideOfClassNode element: self element parent: self) 
												myDependents: (Array with: self);
												yourself )
		with: ((SVNClassSideOfClassNode element: self element parent: self) 
												myDependents: (Array with: self);
												yourself )
		with: ((SVNCommentNode element: self element parent: self) 
												myDependents: (Array with: self);
												yourself )! !

SVNNode subclass: #SVNClassSideOfClassNode
	instanceVariableNames: 'selector label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'rt 3/10/2008 13:24'!
getChildren
	^(self element versionedMethods select: [:each | each isPartOfMetaclass]) collect: [ :each |
			(SVNMethodNode element: each parent: self)
				myDependents: (Array with: self);
				yourself  ]! !

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:51'!
getLabel
	^'class'! !

SVNNode subclass: #SVNCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNCommentNode methodsFor: 'svn functions' stamp: 'rkrk 3/3/2008 10:34'!
delete
	self element comment: String new! !

!SVNCommentNode methodsFor: 'menu' stamp: 'cop 2/27/2008 17:00'!
deleteMenuLabel
	^'Clear comment'! !

!SVNCommentNode methodsFor: 'functionality' stamp: 'cop 2/26/2008 12:06'!
getLabel
	^'comment'! !

SVNNode subclass: #SVNInstanceSideOfClassNode
	instanceVariableNames: 'selector label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'rt 3/10/2008 13:25'!
getChildren
	^(self element versionedMethods select: [:each | each isPartOfMetaclass not]) collect: [ :each |
			(SVNMethodNode element: each parent: self)
				myDependents: (Array with: self);
				yourself  ]! !

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:52'!
getLabel
	^'instance'! !

SVNNode subclass: #SVNMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNNode class methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 16:46'!
element: aSVNElement
	^(self new)
		element: aSVNElement;
		yourself.! !

!SVNNode class methodsFor: 'as yet unclassified' stamp: 'cop 2/27/2008 13:17'!
element: aSVNElement parent: aSVNNode
	^(self new)
		element: aSVNElement;
		parent: aSVNNode;
		yourself.! !

!SVNNode methodsFor: 'svn functions' stamp: 'pe 3/3/2008 11:44'!
commit
	self flag: #TODO.
	SVNCommitBrowser openWith: self element.
	! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 2/27/2008 16:45'!
delete
	self changed: #deleteMe with: self! !

!SVNNode methodsFor: 'menu' stamp: 'cop 2/27/2008 16:59'!
deleteMenuLabel
	^'Delete'! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/26/2008 11:33'!
element
	^element! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/26/2008 11:33'!
element: aSVNElement
	element := aSVNElement! !

!SVNNode methodsFor: 'functionality' stamp: 'cop 2/26/2008 12:14'!
getChildren
	^OrderedCollection new! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 3/3/2008 10:33'!
getLabel
	^ self element theName! !

!SVNNode methodsFor: 'menu' stamp: 'cop 2/27/2008 16:59'!
getMenuOn: aMenu
	aMenu add: 'Update' target: self action: #update.
	aMenu add: 'Commit' target: self action: #commit.
	aMenu addLine.
	aMenu add: 'Revert' target: self action: #revert.
	aMenu add: self deleteMenuLabel target: self action: #delete.
	^aMenu! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/27/2008 13:16'!
parent
	^parent! !

!SVNNode methodsFor: 'accessing' stamp: 'cop 2/27/2008 13:16'!
parent: aSVNNode
	parent := aSVNNode! !

!SVNNode methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:49'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNNode methodsFor: 'svn functions' stamp: 'rkrk 3/3/2008 10:34'!
revert
	self element revert! !

!SVNNode methodsFor: 'svn functions' stamp: 'rkrk 3/3/2008 10:33'!
update
	self element update! !

SVNNode subclass: #SVNProjectNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-Models'!

!SVNProjectNode methodsFor: 'svn functions' stamp: 'rkrk 3/4/2008 04:12'!
addClass
	SVNAddClassDialog open addDependent: self! !

!SVNProjectNode methodsFor: 'svn functions' stamp: 'rkrk 3/4/2008 06:13'!
checkout
	self element checkout.
	self element load.! !

!SVNProjectNode methodsFor: 'functionality' stamp: 'rkrk 3/3/2008 10:36'!
getChildren
	^ self element versionedClasses collect: [ :each | (SVNClassNode element: each parent: self)
												myDependents: (Array with: self). ]! !

!SVNProjectNode methodsFor: 'menu' stamp: 'cop 2/28/2008 12:45'!
getMenuOn: aMenu
	super getMenuOn: aMenu.
	aMenu addLine.
	aMenu add: 'Set working dir' target: self action: #setWC.
	aMenu add: 'Set URL' target: self action: #setURL.
	aMenu add: 'Checkout' target: self action: #checkout.
	aMenu add: 'Add class' target: self action: #addClass.
	^aMenu! !

!SVNProjectNode methodsFor: 'ui' stamp: 'rkrk 3/3/2008 10:36'!
setURL
	(SVNSetURLDialog openWith: self element repositoryURL) myDependents: (Array with: self)! !

!SVNProjectNode methodsFor: 'ui' stamp: 'rkrk 3/3/2008 10:36'!
setWC
	(SVNSetWCPathDialog openWith: self element workingCopyDirectory path ) myDependents: (Array with: self)! !

!SVNProjectNode methodsFor: 'svn functions' stamp: 'rkrk 3/4/2008 05:50'!
update
	self flag: #TODO. "quick fix"
	self checkout.! !

!SVNProjectNode methodsFor: 'updating' stamp: 'rkrk 3/3/2008 19:59'!
update: aSelector with: anObject

	aSelector == 	#editedURL ifTrue: [self element repositoryURL: (anObject asUrl asString ).
									^self ].
	aSelector == 	#editedWCPath ifTrue: [self element workingCopyDirectory: (SVNDirectory on: anObject asString ).
									^self ].
	aSelector == 	#addClass ifTrue: [ (self element addClass: (Smalltalk classNamed: anObject asString )).
									self changed: #updateTree.
									^self ].		
	aSelector == 	#deleteMe ifTrue: [ (self element removeSVNClass: anObject).
									self changed: #updateTree.
									^self ].		
	super update: aSelector with: anObject.! !

Object subclass: #SVNTestDirectory
	instanceVariableNames: 'directory isDirty number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectory subclass: #SVNAwareTestDirectory
	instanceVariableNames: 'workingCopyDirectory repositoryDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNAwareTestDirectory methodsFor: 'consistency' stamp: 'test 3/16/2008 17:23'!
checkConsistency
	
	self isDirty: (self workingCopyDirectory exists and:
					[self workingCopyDirectory entries size = 1]) not.
! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/14/2008 21:47'!
create

	super create.
	self
		createRepository;
		createWorkingCopy.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/14/2008 21:28'!
createRepository
	
	self assert: (FileDirectory on: self repositoryPath) exists not.
	
	self executeViaOSProcessSynchronously: 'svnadmin create "' , self repositoryPath ,'"'.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 01:14'!
createWorkingCopy

	self assert: self repositoryDirectory exists.
	self assert: self workingCopyDirectory exists not.
	
	self executeViaOSProcessSynchronously:
		'svn co ' , self repositoryURLPath , ' "' , self workingCopyDirectory pathName , '"'! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:16'!
directory: aFileDirectory
	super directory: aFileDirectory.
	
	self
		workingCopyDirectory: (aFileDirectory directoryNamed: self nameForWorkingCopy);
		repositoryDirectory: (aFileDirectory directoryNamed: self nameForRepository)! !

!SVNAwareTestDirectory methodsFor: 'OSProcess' stamp: 'rkrk 3/16/2008 07:36'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2].].! !

!SVNAwareTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	^ true! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForRepository

	^ 'repository'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForWorkingCopy

	^ 'workingCopy'! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:02'!
pathForTests

	^ self workingCopyPath! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory

	^ repositoryDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory: aFileDirectory

	repositoryDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:31'!
repositoryPath

	^ self repositoryDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:49'!
repositoryURLPath

	^ self repositoryDirectory asUrl asString! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:11'!
workingCopyDirectory

	^ workingCopyDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:08'!
workingCopyDirectory: aFileDirectory

	workingCopyDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:03'!
workingCopyPath

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory pathName! !

!SVNTestDirectory class methodsFor: 'instance creation' stamp: 'rkrk 3/14/2008 20:39'!
theName: aName basePath: basePath

	^ self new
		directory: (FileDirectory on: basePath , FileDirectory slash , aName);
		yourself.! !

!SVNTestDirectory methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:17'!
checkConsistency
	
	self isDirty: (self directory exists and: [self directory entries size = 0]) not.
! !

!SVNTestDirectory methodsFor: 'clearing' stamp: 'rkrk 3/16/2008 01:24'!
clear

	self directory deleteRecursivelyPlatformIndependent! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:21'!
create

	self directory exists ifTrue: [self reCreate. ^ self].
	self directory assureExistence.
	self isDirty: false.! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory
	^ directory! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory: anObject
	directory := anObject! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'test 3/16/2008 06:25'!
initialize

	super initialize.
	self isDirty: true.
	number := 1000 atRandom.! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 21:58'!
isDirty

	^ isDirty! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:00'!
isDirty: anObject
	isDirty := anObject! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	"I cannot create repositories and stuff"
	^ false! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 21:59'!
pathForTests

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self directory pathName! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:26'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self isDirty ifTrue: [''] ifFalse: ['not ']);
		nextPutAll: 'dirty';
		nextPutAll: ' ' , number asString;
		nextPut: $).! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:25'!
reCreate

	self
		clear;
		create! !

Object subclass: #SVNTestDirectoryManager
	instanceVariableNames: 'currentDirectory basicTestDirectories svnAwareTestDirectories basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

!SVNTestDirectoryManager class methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:10'!
checkConsistency

	self getInstance checkConsistency.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:09'!
createObservingMorph

	"SVNTestDirectoryManager createObservingMorph"
	observingMorph := SVNObservingMorph new.
	observingMorph
		openInWorld;
		start.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 03:05'!
getInstance

	"[SVNTestDirectoryManager getInstance]
	[SVNTestDirectoryManager instance: nil]"
	^ self instance
		ifNil: [instance := self basicNew initialize]
		ifNotNil: [self instance]! !

!SVNTestDirectoryManager class methodsFor: 'class initialization' stamp: 'rkrk 3/16/2008 17:10'!
initialize

	"self initialize"
	super initialize.
	World 
		when: #aboutToEnterWorld
		send: #checkConsistency to: self.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:57'!
instance

	^ instance! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:58'!
instance: instanceOfSelf

	instance := instanceOfSelf! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:10'!
killObservingMorph

	"SVNTestDirectoryManager killObservingMorph"
	observingMorph
		stop;
		delete.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 01:45'!
new

	self error: 'Singleton. Call getInstance'.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 07:02'!
reCreate

	"SVNTestDirectoryManager reCreate"
	[self getInstance reCreateTestDirectories. self beep] fork.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:19'!
uninstall

	self getInstance clear.
	self instance: nil.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 00:25'!
basePath
	^ basePath! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 00:25'!
basePath: anObject
	basePath := anObject! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:45'!
basicReCreateDirectories: directories howMany: number

	| dirtyDirs |
	dirtyDirs := directories select: [:ea | ea isDirty].
	dirtyDirs size > number ifTrue: [dirtyDirs := dirtyDirs first: number].
	dirtyDirs
		do: [:each | each reCreate]
		displayingProgress: 'Recreating dirty test directories'.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
basicTestDirectories
	^ basicTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'test 3/16/2008 06:03'!
basicTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	"self assert: (anObject isKindOf: Array) not."
	basicTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:28'!
checkConsistency

	self testDirectories
		do: [:ea | ea checkConsistency]
		displayingProgress: 'SVNTestDirectoryManager conistency check'.! !

!SVNTestDirectoryManager methodsFor: 'removing' stamp: 'rkrk 3/16/2008 01:27'!
clear

	self testDirectories do: [:ea | ea clear].
	(FileDirectory on: self basePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:29'!
create: number fromClass: SVNDirectoryClass named: partOfName considerExisting: directories
"Create only as many new directories as needed. Reuse old ones"

	| newDirectories |
	^ directories size >= number
		ifTrue: [self reuse: number of: directories]
		ifFalse: [
			newDirectories := (directories size to: number - 1) collect: [:i |
				SVNDirectoryClass
					theName: partOfName , i asString
					basePath: self basePath].
				directories addAll: newDirectories asOrderedCollection.
				directories].! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:39'!
createBasicTestDirectories: number

	self basicTestDirectories: (self
		create: number
		fromClass: SVNTestDirectory
		named: 'SVNTestDirectory_'
		considerExisting: self basicTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:41'!
createBasicTestDirs: numberForBasic svnAwareTestDirs: numberForSvnAware

	| newOrDirtyDirs |
	self assert: self basePath notNil.
	self
		createBasicTestDirectories: numberForBasic;
		createSvnAwareTestDirectories: numberForSvnAware.
	newOrDirtyDirs := self testDirectories select: [:ea | ea isDirty].
	newOrDirtyDirs
		do: [:ea | ea reCreate]
		displayingProgress: 'Creating TestDirectories'.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:38'!
createSvnAwareTestDirectories: number

	self svnAwareTestDirectories: (self
		create: number
		fromClass: SVNAwareTestDirectory
		named: 'SVNAwareTestDirectory_'
		considerExisting: self svnAwareTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory
	^ currentDirectory! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory: anObject
	currentDirectory := anObject! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 02:05'!
findCleanSvnAwareTestDirectory

	self assert: self svnAwareTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware and: [directory isDirty not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 02:06'!
findCleanTestDirectory

	self assert: self basicTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware not and: [directory isDirty not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 03:04'!
findTestDirectoryWhichSatisfies: conditionBlock

	^ self testDirectories
		detect: conditionBlock
		ifNone: [self reCreatePercent: 10.
			self testDirectories detect: conditionBlock].! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:57'!
initialize

	super initialize.
	self
		basicTestDirectories: OrderedCollection new;
		svnAwareTestDirectories: OrderedCollection new.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanBasicTestDirectories

	^ self basicTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanSvnAwareTestDirectories

	^ self svnAwareTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 00:36'!
pathForTests

	self
		assert: self currentDirectory notNil
		description: 'The calling test has not registered for directory support'.
	^ self currentDirectory pathForTests! !

!SVNTestDirectoryManager methodsFor: 'helper' stamp: 'rkrk 3/16/2008 05:18'!
percent: percent of: total

	| result |
	result := (total * (percent / 100)) asInteger.
	result = 0 ifTrue: [^ 1]. "should at least be one"
	^ result! !

!SVNTestDirectoryManager methodsFor: 'printing' stamp: 'rkrk 3/16/2008 03:58'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: 'svn aware: ';
		nextPutAll: self svnAwareTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanSvnAwareTestDirectories asString;
		nextPutAll: ' basic: ';
		nextPutAll: self basicTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanBasicTestDirectories asString;
		nextPut: $).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:47'!
reCreatePercent: percent

	self
		basicReCreateDirectories: self basicTestDirectories
	 	howMany: (self	percent: percent of: self basicTestDirectories size).
	self
		basicReCreateDirectories: self svnAwareTestDirectories
	 	howMany: (self	percent: percent of: self svnAwareTestDirectories size).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:41'!
reCreateTestDirectories

	self reCreatePercent: 100.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForSvnAwareTestDirectory
	
	self currentDirectory: self findCleanSvnAwareTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForTestDirectory
	
	self currentDirectory: self findCleanTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
repositoryURLPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:15'!
reuse: number of: directories

	| directoriesNotNeeded |
	directoriesNotNeeded := (directories last: directories size - number).
	directoriesNotNeeded do: [:ea | ea clear].
	^ (directories first: number) asOrderedCollection! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
svnAwareTestDirectories
	^ svnAwareTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 06:00'!
svnAwareTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	self assert: (anObject isKindOf: Array) not.
	svnAwareTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 02:01'!
testDirectories

	^ self basicTestDirectories union: self svnAwareTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 02:38'!
unregister

	self flag: #TODO. "self currentDirectory: nil"
	self currentDirectory: self findCleanTestDirectory.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
workingCopyPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory workingCopyPath.! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 15:37'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 22:38'!
onlyATest

	<primitive: 'onlyATest' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:27'!
primSvnGetHeadRevision: target

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
added
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
conflicted
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3789677025 4294967295 4292993505 4294967295 3789684735 4292993535 4294967295 4292993535 4293001215 4294967295 4294959615 3791650815 3789677025 4294959585 3791650815 3789677025 3789677025 3791650815 3789677025 3789677025 3791650815 3789677055 4294959585 4293001215 4294967295 4294959615 4292993535 4294967295 4292993535 4294959585 3789677025 3789684735 4294967295 3789677025 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
modified
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3941264106 4294967295 4294961898 3942645738 3941269503 4293585642 4294967295 3941264127 4293585642 4294967295 3941264127 3941264106 4294967295 3941264106 3941264106 4294967295 3941264106 3941264106 3942645738 3941264106 3941264106 3941264106 3941264106 4293585642 3942645738 3941264127 4293585642 4294967295 3941264127 4294961898 3942645738 3941269503 4294967295 3941264106 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
nochanges
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 2038004089 4294967295 4286151033 2038004089 2038038527 4286151033 2038004089 2038004223 4286151033 2038004089 2046786047 2038004089 2038004223 4286151033 2038004089 2038038527 2038004089 2046820217 4294967161 2038004089 2046820351 4294932857 2038004089 4286185471 4286151033 2038004223 4286151167 2038004089 2038004223 4294932857 2038004089 2038038527 4294967295 2038004089 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

OBFilter subclass: #OBSVNStatusIconClassFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'rkrk 3/6/2008 17:18'!
icon: aSymbol forNode: aNode

	(SVNProject allInstances last versionedClasses
		anySatisfy: [:ea | ea theName asString = aNode theClass asString])
			ifTrue: [^ #nochanges].
	^ #blank! !

OBFilter subclass: #OBSVNStatusIconMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNStatusIconMethodFilter methodsFor: 'filtering' stamp: 'rkrk 3/6/2008 17:18'!
icon: aSymbol forNode: aNode

	| method |
	method := aNode theClass lookupSelector: aNode selector.
	method ifNil: [^ #blank].
	(SVNProject allInstances last allVersionedMethods includes: (SVNMethod forExistingMethod: method)) ifTrue: [^ #nochanges].
	^ #blank.! !

OBBrowseRequest subclass: #OBSVNBrowseRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNBrowseRequest methodsFor: 'exceptionDescription' stamp: 'cop 3/6/2008 13:13'!
defaultAction
	^ self handleWith: OBSVNMorphicPlatform new! !

OBSystemBrowser subclass: #OBSVNSystemBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'rkrk 3/6/2008 11:08'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
	^ (OBSVNMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 3/6/2008 13:26'!
definitionPanel
	^ OBSVNDefinitionPanel new! !

!OBSVNSystemBrowser methodsFor: 'command' stamp: 'cop 3/6/2008 12:09'!
cmdMultiView
	^ OBSVNCmdMultiView! !

!OBSVNSystemBrowser methodsFor: 'command' stamp: 'rkrk 3/6/2008 10:52'!
cmdSVNAdd

	^ {OBSVNCmdAddElement}! !

!OBSVNSystemBrowser methodsFor: 'opening' stamp: 'cop 3/6/2008 13:08'!
open
	^ OBSVNBrowseRequest signal: self! !

OBPluggableTextMorphWithShout subclass: #OBSVNPluggableTextMorphWithShout
	instanceVariableNames: 'blame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNPluggableTextMorphWithShout methodsFor: 'accessing' stamp: 'cop 3/6/2008 12:27'!
blame
	^blame! !

!OBSVNPluggableTextMorphWithShout methodsFor: 'accessing' stamp: 'cop 3/6/2008 12:27'!
blame: aBool
	blame := aBool! !

!OBSVNPluggableTextMorphWithShout methodsFor: 'functionality' stamp: 'cop 3/6/2008 13:27'!
checkForBlame
	(model definition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^false]
				ifTrue: [^model definition blame ]! !

!OBSVNPluggableTextMorphWithShout methodsFor: 'functionality' stamp: 'cop 3/6/2008 12:58'!
textChangedHandling
	self checkForBlame  ifTrue: [ self privateSetText: self getText ]
						ifFalse: [ self setText: self getText ].
	^self setSelection: self getSelection! !

!OBSVNPluggableTextMorphWithShout methodsFor: 'updating' stamp: 'cop 3/6/2008 13:17'!
update: aSymbol
	aSymbol == getTextSelector 
	ifTrue: 
		[^self textChangedHandling].
	super update: aSymbol.! !

OBCommand subclass: #OBSVNCmdAddElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UI-SystemBrowserExtension'!

!OBSVNCmdAddElement methodsFor: 'execution' stamp: 'rkrk 3/4/2008 12:32'!
execute
	
	| projectName project |
	projectName := OBTextRequest
				prompt: 'Please type in the name of an existing SVNProject' 
				template: ''.
				
	"self halt."
	project := SVNProject allInstances
		detect: [:each | each theName = projectName]
		ifNone: [^ self].

	project addClass: target theClass.! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:10'!
group
	^ #SVN! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:19'!
icon
	^ #smallOkIcon! !

!OBSVNCmdAddElement methodsFor: 'testing' stamp: 'rkrk 3/4/2008 11:13'!
isActive

	^ ((target isKindOf: OBMethodVersionNode) or: [target isKindOf: OBClassNode])
		and: [requestor isSelected: target]! !

!OBSVNCmdAddElement methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 11:13'!
label
	^ 'add to SVNProject...'! !

!FileDirectory methodsFor: '*SqueakSVN' stamp: 'rkrk 3/16/2008 06:33'!
deleteRecursivelyPlatformIndependent

	| p |
	"You will need the recursiveDelete.bat in a path which OSProcess can reach."
	self exists ifFalse: [^ self].
	SmalltalkImage current platformName =  'Win32'
		ifTrue: [p := ExternalOSProcess command:
			'recursiveDelete.bat ' , self pathName.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 5) wait]].
	self exists ifTrue: [self recursiveDelete].! !

Morph subclass: #SVNObservingMorph
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNObservingMorph methodsFor: 'menus' stamp: 'rkrk 3/16/2008 06:57'!
changeColor

	| mgr ratio |
	mgr := SVNTestDirectoryManager getInstance.
	(mgr basicTestDirectories size = 0 or: [mgr svnAwareTestDirectories size = 0])
		ifTrue: [^ Color blue].
	ratio := mgr numberOfCleanBasicTestDirectories < mgr numberOfCleanSvnAwareTestDirectories
		ifTrue: [mgr numberOfCleanBasicTestDirectories / mgr basicTestDirectories size]
		ifFalse: [mgr numberOfCleanSvnAwareTestDirectories / mgr svnAwareTestDirectories size].
	self color: (Color r: 1 - ratio g: ratio b: 0).! !

!SVNObservingMorph methodsFor: 'as yet unclassified' stamp: 'rkrk 3/16/2008 03:47'!
correctPosition

	self position: self world position x @ (self world height - self height).! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:01'!
handlesMouseDown: evt

	^ true! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:02'!
mouseDown: evt

	SVNTestDirectoryManager reCreate! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rkrk 3/16/2008 06:56'!
start

	process := [
		[self
			correctPosition;
			changeColor.
		(Delay forSeconds: 5) wait] repeat
	] forkAt: Processor userBackgroundPriority.! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rkrk 3/16/2008 04:03'!
stop

	process terminate.! !
SVNTestDirectoryManager initialize!
